
                        .FILE     G:\NAVETTE_PRO\TRAVAUX_A_TRIER\AVRCORS232\ATMEGA_RS232.pas

                        ; Compiled by E-LAB AVRco PASCAL Compiler Rev 5.04.00
                        ; Version     : mega8
                        ;
                        ; Licenced to : Mega8/Mega88 Version
                        ;
                        ; (c), Grombacherstr. 27  e-mail info@e-lab.de
                        ; D-74906 Bad Rappenau  Tel. 07268/9124-0 Fax. 07268/9124-24
                        ; ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        ; Source File : ATMEGA_RS232.pas
                        ; Compiled    : 22. fvrier 2015  15:46:19
                        ; ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

                        .SMALL
                        .ROMEND         01FFFh;
                        .EEPROMEND      001FFh;

                        ; ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        ; Constants and Variables definition
                        ; ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


                        ; === Internal used memory and constants ===

FALSE                   .EQU    000h            ; const 
TRUE                    .EQU    0FFh            ; const 
NIL                     .EQU    000h            ; const 
PI                      .EQU    000h            ; const 
COMPILERREV             .EQU    1F8h            ; const 
COMPILERBUILD_Y         .EQU    00Ch            ; const 
COMPILERBUILD_M         .EQU    006h            ; const 
COMPILERBUILD_D         .EQU    018h            ; const 
COMPILEYEAR             .EQU    00Fh            ; const 
COMPILEMONTH            .EQU    002h            ; const 
COMPILEDAY              .EQU    016h            ; const 
COMPILEHOUR             .EQU    00Fh            ; const 
COMPILEMINUTE           .EQU    02Eh            ; const 
PROJECTBUILD            .EQU    02Eh            ; const 
OPTIMISERREV            .EQU    000h            ; const 
OPTIMISERBUILD          .EQU    000h            ; const 
INTFLAG                 .EQU    007h            ; const 
_EEPROM                 .EQU    006h            ; const 
_SIGN                   .EQU    005h            ; const 
_WAITLCD                .EQU    004h            ; const 
_STRCONST               .EQU    004h            ; const 
_DEVICE                 .EQU    003h            ; const 
_NEGATIVE               .EQU    002h            ; const 
_ERRFLAG                .EQU    001h            ; const 
_I2C2BYTE               .EQU    000h            ; const 
_TOGGLE300              .EQU    000h            ; const 
_LCDLOWER               .EQU    001h            ; const 
_DSP7RFR                .EQU    002h            ; const 
_PWRSAVFLG              .EQU    003h            ; const 
_F64StrInt              .EQU    004h            ; const 
_F64StrFrac             .EQU    005h            ; const 
_FREQCNTFLAG            .EQU    006h            ; const 
_AUTOACK                .EQU    007h            ; const 
_ACCGLO                 .EQU    000h            ; var Data   byte
_ACCGHI                 .EQU    001h            ; var Data   byte
_ACCHLO                 .EQU    002h            ; var Data   byte
_ACCHHI                 .EQU    003h            ; var Data   byte
_ACCB                   .EQU    010h            ; var Data   byte
_ACCA                   .EQU    011h            ; var Data   byte
_ACCALO                 .EQU    012h            ; var Data   byte
_ACCAHI                 .EQU    013h            ; var Data   byte
_ACCDLO                 .EQU    014h            ; var Data   byte
_ACCDHI                 .EQU    015h            ; var Data   byte
_ACCELO                 .EQU    016h            ; var Data   byte
_ACCEHI                 .EQU    017h            ; var Data   byte
_ACCFLO                 .EQU    018h            ; var Data   byte
_ACCFHI                 .EQU    019h            ; var Data   byte
_ACCBLO                 .EQU    01Ah            ; var Data   byte
_ACCBHI                 .EQU    01Bh            ; var Data   byte
_FRAMEPTR               .EQU    01Ch            ; var Data   byte
_FPTRHI                 .EQU    01Dh            ; var Data   byte
_ACCCLO                 .EQU    01Eh            ; var Data   byte
_ACCCHI                 .EQU    01Fh            ; var Data   byte
FLAGS                   .EQU    004h            ; var Data   byte
FLAGS2                  .EQU    005h            ; var Data   byte
_SYSTFLAGS              .EQU    006h            ; var Data   byte
SYSTICK                 .EQU    00Ah            ; const 
PROCCLOCK               .EQU    7A1200h         ; const 
DECIMALSEP              .EQU    02Eh            ; const 
CPU_ID                  .EQU    1E930Ah         ; const 
Flash_Page_Size         .EQU    040h            ; const 
ROMconstPage            .EQU    0FFFFFFFFFFFFFFFFh          ; const 
STACKSIZE               .EQU    032h            ; const 
FRAMESIZE               .EQU    032h            ; const 
SERPORT                 .EQU    2580h           ; const 
_ADCBUFF                .EQU    1CFh            ; var iData  word
UDR1                    .EQU    0C6h            ; var iData  byte
UBRR1H                  .EQU    0C5h            ; var iData  byte
UBRRH                   .EQU    0C5h            ; var iData  byte
UBRR1                   .EQU    0C4h            ; var iData  byte
UBRRL                   .EQU    0C4h            ; var iData  byte
UCSRC                   .EQU    0C2h            ; var iData  byte
UCSR0C                  .EQU    0C2h            ; var iData  byte
UCR1                    .EQU    0C1h            ; var iData  byte
UCSRB                   .EQU    0C1h            ; var iData  byte
UCSR0B                  .EQU    0C1h            ; var iData  byte
USR1                    .EQU    0C0h            ; var iData  byte
UCSRA                   .EQU    0C0h            ; var iData  byte
UCSR0A                  .EQU    0C0h            ; var iData  byte
TWAMR                   .EQU    0BDh            ; var iData  byte
TWCR                    .EQU    0BCh            ; var iData  byte
TWDR                    .EQU    0BBh            ; var iData  byte
TWAR                    .EQU    0BAh            ; var iData  byte
TWSR                    .EQU    0B9h            ; var iData  byte
TWBR                    .EQU    0B8h            ; var iData  byte
ASSR                    .EQU    0B6h            ; var iData  byte
OCR2B                   .EQU    0B4h            ; var iData  byte
OCR2A                   .EQU    0B3h            ; var iData  byte
OCR2                    .EQU    0B3h            ; var iData  byte
TCNT2                   .EQU    0B2h            ; var iData  byte
TCCR2B                  .EQU    0B1h            ; var iData  byte
TCCR2A                  .EQU    0B0h            ; var iData  byte
TCCR2                   .EQU    0B1h            ; var iData  byte
OCR1BH                  .EQU    08Bh            ; var iData  byte
OCR1BL                  .EQU    08Ah            ; var iData  byte
OCR1AH                  .EQU    089h            ; var iData  byte
OCR1AL                  .EQU    088h            ; var iData  byte
ICR1H                   .EQU    087h            ; var iData  byte
ICR1L                   .EQU    086h            ; var iData  byte
TCNT1H                  .EQU    085h            ; var iData  byte
TCNT1L                  .EQU    084h            ; var iData  byte
TCCR1C                  .EQU    082h            ; var iData  byte
TCCR1B                  .EQU    081h            ; var iData  byte
TCCR1A                  .EQU    080h            ; var iData  byte
DIDR1                   .EQU    07Fh            ; var iData  byte
DIDR0                   .EQU    07Eh            ; var iData  byte
ADMUX                   .EQU    07Ch            ; var iData  byte
ADCSR                   .EQU    07Ah            ; var iData  byte
ADCSRB                  .EQU    07Bh            ; var iData  byte
ADCSRA                  .EQU    07Ah            ; var iData  byte
ADCH                    .EQU    079h            ; var iData  byte
ADCL                    .EQU    078h            ; var iData  byte
TIMSK2                  .EQU    070h            ; var iData  byte
TIMSK1                  .EQU    06Fh            ; var iData  byte
TIMSK0                  .EQU    06Eh            ; var iData  byte
PCMSK2                  .EQU    06Dh            ; var iData  byte
PCMSK1                  .EQU    06Ch            ; var iData  byte
PCMSK0                  .EQU    06Bh            ; var iData  byte
EICRA                   .EQU    069h            ; var iData  byte
PCICR                   .EQU    068h            ; var iData  byte
OSCCAL                  .EQU    066h            ; var iData  byte
PRR                     .EQU    064h            ; var iData  byte
CLKPR                   .EQU    061h            ; var iData  byte
WDTCR                   .EQU    060h            ; var iData  byte
SREG                    .EQU    05Fh            ; var pData  byte
SPH                     .EQU    05Eh            ; var pData  byte
SPL                     .EQU    05Dh            ; var pData  byte
SPMCR                   .EQU    057h            ; var pData  byte
SPMCSR                  .EQU    057h            ; var pData  byte
MCUCR                   .EQU    055h            ; var pData  byte
MCUCSR                  .EQU    054h            ; var pData  byte
MCUSR                   .EQU    054h            ; var pData  byte
SMCR                    .EQU    053h            ; var pData  byte
MONDR                   .EQU    051h            ; var pData  byte
ACSR                    .EQU    050h            ; var pData  byte
SPDR                    .EQU    04Eh            ; var pData  byte
SPSR                    .EQU    04Dh            ; var pData  byte
SPCR                    .EQU    04Ch            ; var pData  byte
GPIOR2                  .EQU    04Bh            ; var pData  byte
GPIOR1                  .EQU    04Ah            ; var pData  byte
OCR0B                   .EQU    048h            ; var pData  byte
OCR0A                   .EQU    047h            ; var pData  byte
TCNT0                   .EQU    046h            ; var pData  byte
TCCR0B                  .EQU    045h            ; var pData  byte
TCCR0A                  .EQU    044h            ; var pData  byte
TCCR0                   .EQU    045h            ; var pData  byte
GTCCR                   .EQU    043h            ; var pData  byte
EEARH                   .EQU    042h            ; var pData  byte
EEARL                   .EQU    041h            ; var pData  byte
EEDR                    .EQU    040h            ; var pData  byte
EECR                    .EQU    03Fh            ; var pData  byte
GPIOR0                  .EQU    03Eh            ; var pData  byte
GIMSK                   .EQU    03Dh            ; var pData  byte
EIMSK                   .EQU    03Dh            ; var pData  byte
GIFR                    .EQU    03Ch            ; var pData  byte
EIFR                    .EQU    03Ch            ; var pData  byte
PCIFR                   .EQU    03Bh            ; var pData  byte
TIFR2                   .EQU    037h            ; var pData  byte
TIFR1                   .EQU    036h            ; var pData  byte
TIFR0                   .EQU    035h            ; var pData  byte
PORTD                   .EQU    02Bh            ; var pData  byte
DDRD                    .EQU    02Ah            ; var pData  byte
PIND                    .EQU    029h            ; var pData  byte
PORTC                   .EQU    028h            ; var pData  byte
DDRC                    .EQU    027h            ; var pData  byte
PINC                    .EQU    026h            ; var pData  byte
PORTB                   .EQU    025h            ; var pData  byte
DDRB                    .EQU    024h            ; var pData  byte
PINB                    .EQU    023h            ; var pData  byte
OCR1B                   .EQU    08Ah            ; var iData  word
OCR1A                   .EQU    088h            ; var iData  word
ICR1                    .EQU    086h            ; var iData  word
TCNT1                   .EQU    084h            ; var iData  word
ADC                     .EQU    078h            ; var iData  word
EEAR                    .EQU    041h            ; var pData  word
_iDataStart             .EQU    100h            ; const 
_iDataEnd               .EQU    4FFh            ; const 
_EEpromStart            .EQU    000h            ; const 
_EEpromEnd              .EQU    1FFh            ; const 
_FlashStart             .EQU    000h            ; const 
_FlashEnd               .EQU    1FFFh           ; const 
parNone                 .EQU    000h            ; const 
parEven                 .EQU    001h            ; const 
parOdd                  .EQU    002h            ; const 
DataBit5                .EQU    000h            ; const 
DataBit6                .EQU    001h            ; const 
DataBit7                .EQU    002h            ; const 
DataBit8                .EQU    003h            ; const 
StopBit1                .EQU    000h            ; const 
StopBit2                .EQU    001h            ; const 
_RXINP                  .EQU    101h            ; var iData  byte
_RXOUTP                 .EQU    102h            ; var iData  byte
_RXCOUNT                .EQU    103h            ; var iData  byte
_RXBUFF                 .EQU    104h            ; var iData  byte
_TXINP                  .EQU    168h            ; var iData  byte
_TXOUTP                 .EQU    169h            ; var iData  byte
_TXCOUNT                .EQU    16Ah            ; var iData  byte
_TXBUFF                 .EQU    16Bh            ; var iData  byte
SysTickTime             .EQU    100h            ; var iData  byte
EEPROM                  .EQU    000h            ; var EEprom array
EEPROMEND               .EQU    1FFh            ; const 



                        .RESET     000000h
                        .ORG       000000h, CODE_START
                        .STARTCODE 000034h

                        .UNIT     TEST_RS232

                        .XDATASTART -1


                        ; ============ user definitions module: TEST_RS232 ============

                        .SYM      BP, 001D1h, 0000Dh, 3
TEST_RS232.BP           .EQU    1D1h            ; var iData  byte
                        .SYM      ADC_Channel, 001D2h, 0000Eh, 3
TEST_RS232.ADC_Channel  .EQU    1D2h            ; var iData  word
                        .SYM      ADC_Low, 001D2h, 0000Dh, 3
TEST_RS232.ADC_Low      .EQU    1D2h            ; var iData  byte
                        .SYM      ADC_Hi, 001D3h, 0000Dh, 3
TEST_RS232.ADC_Hi       .EQU    1D3h            ; var iData  byte
                        .SYM      ADC_Channel_Integer, 001D2h, 00004h, 3
TEST_RS232.ADC_Channel_Integer  .EQU            1D2h        ; var iData  integer
                        .SYM      i, 001D4h, 0000Dh, 3
TEST_RS232.i            .EQU    1D4h            ; var iData  byte
                        .SYM      Receive, 001D5h, 0000Dh, 3
TEST_RS232.Receive      .EQU    1D5h            ; var iData  byte
                        .SYM      Count, 001D6h, 0000Dh, 3
TEST_RS232.Count        .EQU    1D6h            ; var iData  byte
                        .FUNC     InitPorts, 00057h, 00020h
TEST_RS232.InitPorts:
                        .RETURNS   0
                        .BLOCK    88
                        .LINE     89
                        LDI       _ACCA, 007h
                        OUT       PORTC, _ACCA
                        .ENDBLOCK 90
TEST_RS232.InitPorts_X:
                        .LINE     90
                        .BRANCH   19
                        RET
                        .ENDFUNC  90

                        .FUNC     TestBP, 0005Dh, 00020h
TEST_RS232.TestBP:
                        .RETURNS   0
                        .BLOCK    94
                        .LINE     95
                        CLR       _ACCA
                        SBIC      026h, 002h
                        SER       _ACCA
                        COM       _ACCA
                        PUSH      _ACCA
                        LDS       _ACCB, 001D1h
                        CLR       _ACCA
                        SBRC      _ACCB, 000h
                        SER       _ACCA
                        POP       _ACCB
                        AND       _ACCA, _ACCB
                        TST       _ACCA
                        .BRANCH   4,TEST_RS232._L0002
                        BRNE      TEST_RS232._L0002
                        .BRANCH   20,TEST_RS232._L0000
                        RJMP      TEST_RS232._L0000
TEST_RS232._L0002:
                        .BLOCK    96
                        .LINE     96
                        LDS       _ACCA, 001D1h
                        SBR       _ACCA, 002h
                        STS       001D1h, _ACCA
                        .ENDBLOCK 97
                        .BRANCH   20,TEST_RS232._L0001
                        RJMP      TEST_RS232._L0001
TEST_RS232._L0000:
                        .BLOCK    97
                        .LINE     97
                        LDS       _ACCA, 001D1h
                        CBR       _ACCA, 002h
                        STS       001D1h, _ACCA
                        .ENDBLOCK 98
TEST_RS232._L0001:
                        .LINE     99
                        CLR       _ACCA
                        SBIC      026h, 002h
                        SER       _ACCA
                        CLT
                        TST       _ACCA
                        BREQ      TEST_RS232._L0003
                        SET
TEST_RS232._L0003:
                        LDS       _ACCA, 001D1h
                        BLD       _ACCA, 000h
                        STS       001D1h, _ACCA
                        .LINE     101
                        CLR       _ACCA
                        SBIC      026h, 001h
                        SER       _ACCA
                        COM       _ACCA
                        PUSH      _ACCA
                        LDS       _ACCB, 001D1h
                        CLR       _ACCA
                        SBRC      _ACCB, 002h
                        SER       _ACCA
                        POP       _ACCB
                        AND       _ACCA, _ACCB
                        TST       _ACCA
                        .BRANCH   4,TEST_RS232._L0007
                        BRNE      TEST_RS232._L0007
                        .BRANCH   20,TEST_RS232._L0005
                        RJMP      TEST_RS232._L0005
TEST_RS232._L0007:
                        .BLOCK    102
                        .LINE     102
                        LDS       _ACCA, 001D1h
                        SBR       _ACCA, 008h
                        STS       001D1h, _ACCA
                        .ENDBLOCK 103
                        .BRANCH   20,TEST_RS232._L0006
                        RJMP      TEST_RS232._L0006
TEST_RS232._L0005:
                        .BLOCK    103
                        .LINE     103
                        LDS       _ACCA, 001D1h
                        CBR       _ACCA, 008h
                        STS       001D1h, _ACCA
                        .ENDBLOCK 104
TEST_RS232._L0006:
                        .LINE     105
                        CLR       _ACCA
                        SBIC      026h, 001h
                        SER       _ACCA
                        CLT
                        TST       _ACCA
                        BREQ      TEST_RS232._L0008
                        SET
TEST_RS232._L0008:
                        LDS       _ACCA, 001D1h
                        BLD       _ACCA, 002h
                        STS       001D1h, _ACCA
                        .LINE     107
                        CLR       _ACCA
                        SBIC      026h, 000h
                        SER       _ACCA
                        COM       _ACCA
                        PUSH      _ACCA
                        LDS       _ACCB, 001D1h
                        CLR       _ACCA
                        SBRC      _ACCB, 004h
                        SER       _ACCA
                        POP       _ACCB
                        AND       _ACCA, _ACCB
                        TST       _ACCA
                        .BRANCH   4,TEST_RS232._L0012
                        BRNE      TEST_RS232._L0012
                        .BRANCH   20,TEST_RS232._L0010
                        RJMP      TEST_RS232._L0010
TEST_RS232._L0012:
                        .BLOCK    108
                        .LINE     108
                        LDS       _ACCA, 001D1h
                        SBR       _ACCA, 020h
                        STS       001D1h, _ACCA
                        .ENDBLOCK 109
                        .BRANCH   20,TEST_RS232._L0011
                        RJMP      TEST_RS232._L0011
TEST_RS232._L0010:
                        .BLOCK    109
                        .LINE     109
                        LDS       _ACCA, 001D1h
                        CBR       _ACCA, 020h
                        STS       001D1h, _ACCA
                        .ENDBLOCK 110
TEST_RS232._L0011:
                        .LINE     111
                        CLR       _ACCA
                        SBIC      026h, 000h
                        SER       _ACCA
                        CLT
                        TST       _ACCA
                        BREQ      TEST_RS232._L0013
                        SET
TEST_RS232._L0013:
                        LDS       _ACCA, 001D1h
                        BLD       _ACCA, 004h
                        STS       001D1h, _ACCA
                        .ENDBLOCK 112
TEST_RS232.TestBP_X:
                        .LINE     112
                        .BRANCH   19
                        RET
                        .ENDFUNC  112



                        ; ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        ; Program body
                        ; ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

                        .FUNC     $_Main, 00076h, 00020h
                        .ENTRYMAIN $
TEST_RS232.$_Main:

                        .BLOCK    118
                        .LINE     119
                        .BRANCH   17,TEST_RS232.INITPORTS
                        RCALL     TEST_RS232.INITPORTS

                        .LINE     120
                        LDI       _ACCA, 1 SHLB IntFlag
                        OR        Flags, _ACCA
                        SEI
                        .LINE     121
                        LDI       _ACCA, 000h
                        STS       TEST_RS232.COUNT, _ACCA
                        .LINE     123
                        PUSH      _FRAMEPTR
                        PUSH      _FPTRHI
                        LDI       _ACCA, 000h
                        ST        -Y, _ACCA
                        .FRAME  1
                        LDI       _ACCA, 000h
                        ST        -Y, _ACCA
                        .FRAME  2
                        .FRAME  0
                        RCALL     SYSTEM.LCDXY
                        POP       _FPTRHI
                        POP       _FRAMEPTR

                        .LINE     124
                        PUSH      _FRAMEPTR
                        PUSH      _FPTRHI
                        LDI       _ACCA, 1 SHLB _DEVICE
                        OR        Flags, _ACCA
                        LDI       _ACCB, SYSTEM.LcdOut SHRB 1
                        LDI       _ACCA, SYSTEM.LcdOut SHRB 9
                        ST        -Y, _ACCA
                        ST        -Y, _ACCB
                        .FRAME  2
                        LDI       _ACCCLO, $St_String1 AND 0FFh
                        LDI       _ACCCHI, $St_String1 SHRB 8
                        RCALL     SYSTEM.StrConst2Str
TEST_RS232._L0015:
                        POP       _FPTRHI
                        POP       _FRAMEPTR
                        .FRAME  0
                        .LINE     125
                        PUSH      _FRAMEPTR
                        PUSH      _FPTRHI
                        LDI       _ACCA, 000h
                        ST        -Y, _ACCA
                        .FRAME  1
                        LDI       _ACCA, 001h
                        ST        -Y, _ACCA
                        .FRAME  2
                        .FRAME  0
                        RCALL     SYSTEM.LCDXY
                        POP       _FPTRHI
                        POP       _FRAMEPTR

                        .LINE     126
                        PUSH      _FRAMEPTR
                        PUSH      _FPTRHI
                        LDI       _ACCA, 1 SHLB _DEVICE
                        OR        Flags, _ACCA
                        LDI       _ACCB, SYSTEM.LcdOut SHRB 1
                        LDI       _ACCA, SYSTEM.LcdOut SHRB 9
                        ST        -Y, _ACCA
                        ST        -Y, _ACCB
                        .FRAME  2
                        LDI       _ACCCLO, $St_String2 AND 0FFh
                        LDI       _ACCCHI, $St_String2 SHRB 8
                        RCALL     SYSTEM.StrConst2Str
TEST_RS232._L0016:
                        POP       _FPTRHI
                        POP       _FRAMEPTR
                        .FRAME  0
                        .LINE     127
                        LDI       _ACCA, 000C8h SHRB 8
                        LDI       _ACCB, 000C8h AND 0FFh
                        .FRAME  0
                        RCALL     SYSTEM.MDELAY

                        .LINE     129
                        .LOOP
                        LDI       _ACCCLO, TEST_RS232.i AND 0FFh
                        LDI       _ACCCHI, TEST_RS232.i SHRB 8
                        ST        -Y, _ACCCHI
                        ST        -Y, _ACCCLO
                        .FRAME  2
                        LDI       _ACCA, 000h
                        ST        Z, _ACCA
                        LDI       _ACCA, 013h
                        ST        -Y, _ACCA
                        .FRAME  3
                        LD        _ACCA, Z
TEST_RS232._L0019:
                        LDD       _ACCB, Y+000h
                        CP        _ACCB, _ACCA
                        LDI       _ACCA, 0FFh
                        BRLO      TEST_RS232._L0020
                        CLR       _ACCA
TEST_RS232._L0020:
                        TST       _ACCA
                        .BRANCH   3,TEST_RS232._L0021
                        BREQ      TEST_RS232._L0021
                        .BRANCH   20,TEST_RS232._L0018
                        RJMP      TEST_RS232._L0018
TEST_RS232._L0021:
                        .BLOCK    130
                        .LINE     130
                        PUSH      _FRAMEPTR
                        PUSH      _FPTRHI
                        LDS       _ACCA, TEST_RS232.i
                        ST        -Y, _ACCA
                        .FRAME  4
                        LDI       _ACCA, 003h
                        ST        -Y, _ACCA
                        .FRAME  5
                        .FRAME  3
                        RCALL     SYSTEM.LCDXY
                        POP       _FPTRHI
                        POP       _FRAMEPTR

                        .LINE     130
                        PUSH      _FRAMEPTR
                        PUSH      _FPTRHI
                        LDI       _ACCA, 1 SHLB _DEVICE
                        OR        Flags, _ACCA
                        LDI       _ACCB, SYSTEM.LcdOut SHRB 1
                        LDI       _ACCA, SYSTEM.LcdOut SHRB 9
                        ST        -Y, _ACCA
                        ST        -Y, _ACCB
                        .FRAME  5
                        LDI       _ACCA, 02Ah
                        RCALL     SYSTEM.Char2Str
                        POP       _FPTRHI
                        POP       _FRAMEPTR
                        .FRAME  3
                        .LINE     131
                        LDI       _ACCA, 00032h SHRB 8
                        LDI       _ACCB, 00032h AND 0FFh
                        .FRAME  3
                        RCALL     SYSTEM.MDELAY

                        .ENDBLOCK 132
TEST_RS232._L0017:
                        .LINE     132
                        LDD       _ACCCLO, Y+001h
                        LDD       _ACCCHI, Y+002h
                        LD        _ACCA, Z
                        INC       _ACCA
                        ST        Z, _ACCA
                        TST       _ACCA
                        .BRANCH   3,TEST_RS232._L0018
                        BREQ      TEST_RS232._L0018
                        .BRANCH   20,TEST_RS232._L0019
                        RJMP      TEST_RS232._L0019
TEST_RS232._L0018:
                        ADIW      _FRAMEPTR, 3
                        .FRAME  0
                        .ENDLOOP
                        .LINE     133
                        RCALL     SYSTEM.LCDCLR

                        .LINE     134
                        PUSH      _FRAMEPTR
                        PUSH      _FPTRHI
                        LDI       _ACCA, 1 SHLB _DEVICE
                        OR        Flags, _ACCA
                        LDI       _ACCB, SYSTEM.LcdOut SHRB 1
                        LDI       _ACCA, SYSTEM.LcdOut SHRB 9
                        ST        -Y, _ACCA
                        ST        -Y, _ACCB
                        .FRAME  2
                        LDI       _ACCCLO, $St_String3 AND 0FFh
                        LDI       _ACCCHI, $St_String3 SHRB 8
                        RCALL     SYSTEM.StrConst2Str
TEST_RS232._L0022:
                        POP       _FPTRHI
                        POP       _FRAMEPTR
                        .FRAME  0
                        .LINE     135
                        PUSH      _FRAMEPTR
                        PUSH      _FPTRHI
                        LDI       _ACCA, 000h
                        ST        -Y, _ACCA
                        .FRAME  1
                        LDI       _ACCA, 001h
                        ST        -Y, _ACCA
                        .FRAME  2
                        .FRAME  0
                        RCALL     SYSTEM.LCDXY
                        POP       _FPTRHI
                        POP       _FRAMEPTR

                        .LINE     136
                        PUSH      _FRAMEPTR
                        PUSH      _FPTRHI
                        LDI       _ACCA, 1 SHLB _DEVICE
                        OR        Flags, _ACCA
                        LDI       _ACCB, SYSTEM.LcdOut SHRB 1
                        LDI       _ACCA, SYSTEM.LcdOut SHRB 9
                        ST        -Y, _ACCA
                        ST        -Y, _ACCB
                        .FRAME  2
                        LDI       _ACCCLO, $St_String4 AND 0FFh
                        LDI       _ACCCHI, $St_String4 SHRB 8
                        RCALL     SYSTEM.StrConst2Str
TEST_RS232._L0023:
                        POP       _FPTRHI
                        POP       _FRAMEPTR
                        .FRAME  0
                        .LINE     137
                        LDI       _ACCA, 007D0h SHRB 8
                        LDI       _ACCB, 007D0h AND 0FFh
                        .FRAME  0
                        RCALL     SYSTEM.MDELAY

                        .LINE     138
                        RCALL     SYSTEM.LCDCLR

                        .LINE     140
                        PUSH      _FRAMEPTR
                        PUSH      _FPTRHI
                        LDI       _ACCA, 000h
                        ST        -Y, _ACCA
                        .FRAME  1
                        LDI       _ACCA, 002h
                        ST        -Y, _ACCA
                        .FRAME  2
                        .FRAME  0
                        RCALL     SYSTEM.LCDXY
                        POP       _FPTRHI
                        POP       _FRAMEPTR

                        .LINE     141
                        PUSH      _FRAMEPTR
                        PUSH      _FPTRHI
                        LDI       _ACCA, 1 SHLB _DEVICE
                        OR        Flags, _ACCA
                        LDI       _ACCB, SYSTEM.LcdOut SHRB 1
                        LDI       _ACCA, SYSTEM.LcdOut SHRB 9
                        ST        -Y, _ACCA
                        ST        -Y, _ACCB
                        .FRAME  2
                        LDI       _ACCCLO, $St_String5 AND 0FFh
                        LDI       _ACCCHI, $St_String5 SHRB 8
                        RCALL     SYSTEM.StrConst2Str
TEST_RS232._L0024:
                        POP       _FPTRHI
                        POP       _FRAMEPTR
                        .FRAME  0
TEST_RS232._L0025:
                        .BLOCK    143
                        .LINE     144
                        .BRANCH   17,TEST_RS232.TESTBP
                        RCALL     TEST_RS232.TESTBP

                        .LINE     147
                        RCALL      SYSTEM.GETADC

                        ANDI      _ACCB, 0FFh
                        ANDI      _ACCA, 003h
                        STS       TEST_RS232.ADC_CHANNEL, _ACCB
                        STS       TEST_RS232.ADC_CHANNEL+1, _ACCA
                        .LINE     148
                        PUSH      _FRAMEPTR
                        PUSH      _FPTRHI
                        LDI       _ACCA, 000h
                        ST        -Y, _ACCA
                        .FRAME  1
                        LDI       _ACCA, 000h
                        ST        -Y, _ACCA
                        .FRAME  2
                        .FRAME  0
                        RCALL     SYSTEM.LCDXY
                        POP       _FPTRHI
                        POP       _FRAMEPTR

                        .LINE     148
                        PUSH      _FRAMEPTR
                        PUSH      _FPTRHI
                        LDI       _ACCA, 1 SHLB _DEVICE
                        OR        Flags, _ACCA
                        LDI       _ACCB, SYSTEM.LCDout SHRB 1
                        LDI       _ACCA, SYSTEM.LCDout SHRB 9
                        ST        -Y, _ACCA
                        ST        -Y, _ACCB
                        .FRAME  2
                        LDI       _ACCCLO, $St_String6 AND 0FFh
                        LDI       _ACCCHI, $St_String6 SHRB 8
                        RCALL     SYSTEM.StrConst2Str
TEST_RS232._L0027:
                        LDS       _ACCB, TEST_RS232.ADC_Channel_Integer
                        LDS       _ACCA, TEST_RS232.ADC_Channel_Integer+1
                        PUSH      _FRAMEPTR
                        PUSH      _FPTRHI
                        ST        -Y, _ACCA
                        ST        -Y, _ACCB
                        .FRAME  4
                        LDI       _ACCA, 004h
                        ST        -Y, _ACCA
                        .FRAME  5
                        LDI       _ACCB, 000h
                        ST        -Y, _ACCB
                        LDI       _ACCA, 020h
                        ST        -Y, _ACCA
                        .FRAME  7
                        SET
                        BLD       Flags, _DEVICE
                        SET
                        BLD       Flags, _SIGN
                        CLT
                        BLD       Flags2, _F64StrInt
                        BLD       Flags2, _F64StrFrac
                        RCALL     SYSTEM.Int2Str
                        .FRAME  2
                        POP       _FPTRHI
                        POP       _FRAMEPTR
                        LDI       _ACCCLO, $St_String7 AND 0FFh
                        LDI       _ACCCHI, $St_String7 SHRB 8
                        RCALL     SYSTEM.StrConst2Str
TEST_RS232._L0028:
                        LDS       _ACCB, TEST_RS232.ADC_Channel
                        LDS       _ACCA, TEST_RS232.ADC_Channel+1
                        CLR       _ACCAHI
                        CLR       _ACCALO
                        CLT
                        BLD       Flags, _SIGN
                        CLT
                        BLD       Flags, _ERRFLAG
                        RCALL     SYSTEM.LIntToFloat
                        PUSH      _ACCB
                        PUSH      _ACCA
                        PUSH      _ACCALO
                        PUSH      _ACCAHI
                        POP       _ACCEHI
                        POP       _ACCELO
                        POP       _ACCDHI
                        POP       _ACCDLO
                        LDI       _ACCBLO, 000h
                        LDI       _ACCBHI, 000h
                        LDI       _ACCCLO, 0A0h
                        LDI       _ACCCHI, 03Bh
                        CLT
                        BLD       Flags, _ERRFLAG
                        RCALL     SYSTEM.MulFloat_R
                        ST        -Y, _ACCAHI
                        ST        -Y, _ACCALO
                        ST        -Y, _ACCA
                        ST        -Y, _ACCB
                        .FRAME  6
                        LDI       _ACCA, 006h
                        ST        -Y, _ACCA
                        .FRAME  7
                        LDI       _ACCA, 004h
                        ST        -Y, _ACCA
                        .FRAME  8
                        LDI       _ACCA, 020h
                        ST        -Y, _ACCA
                        .FRAME  9
                        SET
                        BLD       Flags, _DEVICE
                        RCALL     SYSTEM.Float2Str
                        .FRAME  2
                        LDI       _ACCA, 056h
                        RCALL     SYSTEM.Char2Str
                        POP       _FPTRHI
                        POP       _FRAMEPTR
                        .FRAME  0
                        .LINE     152
                        LDS       _ACCB, 001D1h
                        CLR       _ACCA
                        SBRC      _ACCB, 001h
                        SER       _ACCA
                        TST       _ACCA
                        .BRANCH   4,TEST_RS232._L0031
                        BRNE      TEST_RS232._L0031
                        .BRANCH   20,TEST_RS232._L0029
                        RJMP      TEST_RS232._L0029
TEST_RS232._L0031:
                        .BLOCK    152
                        .LINE     153
                        PUSH      _FRAMEPTR
                        PUSH      _FPTRHI
                        LDI       _ACCA, 000h
                        ST        -Y, _ACCA
                        .FRAME  1
                        LDI       _ACCA, 003h
                        ST        -Y, _ACCA
                        .FRAME  2
                        .FRAME  0
                        RCALL     SYSTEM.LCDXY
                        POP       _FPTRHI
                        POP       _FRAMEPTR

                        .LINE     154
                        PUSH      _FRAMEPTR
                        PUSH      _FPTRHI
                        LDI       _ACCA, 1 SHLB _DEVICE
                        OR        Flags, _ACCA
                        LDI       _ACCB, SYSTEM.LcdOut SHRB 1
                        LDI       _ACCA, SYSTEM.LcdOut SHRB 9
                        ST        -Y, _ACCA
                        ST        -Y, _ACCB
                        .FRAME  2
                        LDI       _ACCCLO, $St_String8 AND 0FFh
                        LDI       _ACCCHI, $St_String8 SHRB 8
                        RCALL     SYSTEM.StrConst2Str
TEST_RS232._L0032:
                        POP       _FPTRHI
                        POP       _FRAMEPTR
                        .FRAME  0
                        .LINE     155
                        LDI       _ACCA, 000h
                        STS       TEST_RS232.COUNT, _ACCA
                        .ENDBLOCK 156
TEST_RS232._L0029:
TEST_RS232._L0030:
                        .LINE     158
                        LDS       _ACCB, 001D1h
                        CLR       _ACCA
                        SBRC      _ACCB, 003h
                        SER       _ACCA
                        TST       _ACCA
                        .BRANCH   4,TEST_RS232._L0035
                        BRNE      TEST_RS232._L0035
                        .BRANCH   20,TEST_RS232._L0033
                        RJMP      TEST_RS232._L0033
TEST_RS232._L0035:
                        .BLOCK    158
                        .LINE     159
                        PUSH      _FRAMEPTR
                        PUSH      _FPTRHI
                        LDI       _ACCA, 000h
                        ST        -Y, _ACCA
                        .FRAME  1
                        LDI       _ACCA, 001h
                        ST        -Y, _ACCA
                        .FRAME  2
                        .FRAME  0
                        RCALL     SYSTEM.LCDXY
                        POP       _FPTRHI
                        POP       _FRAMEPTR

                        .LINE     160
                        PUSH      _FRAMEPTR
                        PUSH      _FPTRHI
                        LDI       _ACCA, 1 SHLB _DEVICE
                        OR        Flags, _ACCA
                        LDI       _ACCB, SYSTEM.LcdOut SHRB 1
                        LDI       _ACCA, SYSTEM.LcdOut SHRB 9
                        ST        -Y, _ACCA
                        ST        -Y, _ACCB
                        .FRAME  2
                        LDI       _ACCCLO, $St_String9 AND 0FFh
                        LDI       _ACCCHI, $St_String9 SHRB 8
                        RCALL     SYSTEM.StrConst2Str
TEST_RS232._L0036:
                        POP       _FPTRHI
                        POP       _FRAMEPTR
                        .FRAME  0
                        .LINE     161
                        LDI       _ACCA, 042h
                        .FRAME  0
                        RCALL     SYSTEM.SEROUT

                        .LINE     161
                        LDI       _ACCA, 06Fh
                        .FRAME  0
                        RCALL     SYSTEM.SEROUT

                        .LINE     161
                        LDI       _ACCA, 06Eh
                        .FRAME  0
                        RCALL     SYSTEM.SEROUT

                        .LINE     161
                        LDI       _ACCA, 06Ah
                        .FRAME  0
                        RCALL     SYSTEM.SEROUT

                        .LINE     162
                        LDI       _ACCA, 06Fh
                        .FRAME  0
                        RCALL     SYSTEM.SEROUT

                        .LINE     162
                        LDI       _ACCA, 075h
                        .FRAME  0
                        RCALL     SYSTEM.SEROUT

                        .LINE     162
                        LDI       _ACCA, 072h
                        .FRAME  0
                        RCALL     SYSTEM.SEROUT

                        .LINE     163
                        LDI       _ACCA, 007D0h SHRB 8
                        LDI       _ACCB, 007D0h AND 0FFh
                        .FRAME  0
                        RCALL     SYSTEM.MDELAY

                        .LINE     164
                        PUSH      _FRAMEPTR
                        PUSH      _FPTRHI
                        LDI       _ACCA, 000h
                        ST        -Y, _ACCA
                        .FRAME  1
                        LDI       _ACCA, 001h
                        ST        -Y, _ACCA
                        .FRAME  2
                        .FRAME  0
                        RCALL     SYSTEM.LCDXY
                        POP       _FPTRHI
                        POP       _FRAMEPTR

                        .LINE     165
                        PUSH      _FRAMEPTR
                        PUSH      _FPTRHI
                        LDI       _ACCA, 1 SHLB _DEVICE
                        OR        Flags, _ACCA
                        LDI       _ACCB, SYSTEM.LcdOut SHRB 1
                        LDI       _ACCA, SYSTEM.LcdOut SHRB 9
                        ST        -Y, _ACCA
                        ST        -Y, _ACCB
                        .FRAME  2
                        LDI       _ACCCLO, $St_String8 AND 0FFh
                        LDI       _ACCCHI, $St_String8 SHRB 8
                        RCALL     SYSTEM.StrConst2Str
TEST_RS232._L0037:
                        POP       _FPTRHI
                        POP       _FRAMEPTR
                        .FRAME  0
                        .ENDBLOCK 166
TEST_RS232._L0033:
TEST_RS232._L0034:
                        .LINE     169
                        LDS       _ACCB, 001D1h
                        CLR       _ACCA
                        SBRC      _ACCB, 005h
                        SER       _ACCA
                        TST       _ACCA
                        .BRANCH   4,TEST_RS232._L0040
                        BRNE      TEST_RS232._L0040
                        .BRANCH   20,TEST_RS232._L0038
                        RJMP      TEST_RS232._L0038
TEST_RS232._L0040:
                        .BLOCK    169
                        .LINE     170
                        PUSH      _FRAMEPTR
                        PUSH      _FPTRHI
                        LDI       _ACCA, 000h
                        ST        -Y, _ACCA
                        .FRAME  1
                        LDI       _ACCA, 001h
                        ST        -Y, _ACCA
                        .FRAME  2
                        .FRAME  0
                        RCALL     SYSTEM.LCDXY
                        POP       _FPTRHI
                        POP       _FRAMEPTR

                        .LINE     171
                        PUSH      _FRAMEPTR
                        PUSH      _FPTRHI
                        LDI       _ACCA, 1 SHLB _DEVICE
                        OR        Flags, _ACCA
                        LDI       _ACCB, SYSTEM.LcdOut SHRB 1
                        LDI       _ACCA, SYSTEM.LcdOut SHRB 9
                        ST        -Y, _ACCA
                        ST        -Y, _ACCB
                        .FRAME  2
                        LDI       _ACCCLO, $St_String10 AND 0FFh
                        LDI       _ACCCHI, $St_String10 SHRB 8
                        RCALL     SYSTEM.StrConst2Str
TEST_RS232._L0041:
                        POP       _FPTRHI
                        POP       _FRAMEPTR
                        .FRAME  0
                        .LINE     171
                        LDS       _ACCA, TEST_RS232.ADC_Hi
                        .FRAME  0
                        RCALL     SYSTEM.SEROUT

                        .LINE     171
                        LDS       _ACCA, TEST_RS232.ADC_Low
                        .FRAME  0
                        RCALL     SYSTEM.SEROUT

                        .LINE     172
                        LDI       _ACCA, 007D0h SHRB 8
                        LDI       _ACCB, 007D0h AND 0FFh
                        .FRAME  0
                        RCALL     SYSTEM.MDELAY

                        .LINE     173
                        PUSH      _FRAMEPTR
                        PUSH      _FPTRHI
                        LDI       _ACCA, 000h
                        ST        -Y, _ACCA
                        .FRAME  1
                        LDI       _ACCA, 001h
                        ST        -Y, _ACCA
                        .FRAME  2
                        .FRAME  0
                        RCALL     SYSTEM.LCDXY
                        POP       _FPTRHI
                        POP       _FRAMEPTR

                        .LINE     174
                        PUSH      _FRAMEPTR
                        PUSH      _FPTRHI
                        LDI       _ACCA, 1 SHLB _DEVICE
                        OR        Flags, _ACCA
                        LDI       _ACCB, SYSTEM.LcdOut SHRB 1
                        LDI       _ACCA, SYSTEM.LcdOut SHRB 9
                        ST        -Y, _ACCA
                        ST        -Y, _ACCB
                        .FRAME  2
                        LDI       _ACCCLO, $St_String8 AND 0FFh
                        LDI       _ACCCHI, $St_String8 SHRB 8
                        RCALL     SYSTEM.StrConst2Str
TEST_RS232._L0042:
                        POP       _FPTRHI
                        POP       _FRAMEPTR
                        .FRAME  0
                        .ENDBLOCK 175
TEST_RS232._L0038:
TEST_RS232._L0039:
                        .LINE     178
                        RCALL      SYSTEM.SERSTAT

                        TST       _ACCA
                        .BRANCH   4,TEST_RS232._L0045
                        BRNE      TEST_RS232._L0045
                        .BRANCH   20,TEST_RS232._L0043
                        RJMP      TEST_RS232._L0043
TEST_RS232._L0045:
                        .BLOCK    178
                        .LINE     179
                        RCALL      SYSTEM.SERINP

                        STS       TEST_RS232.RECEIVE, _ACCA
                        .LINE     180
                        PUSH      _FRAMEPTR
                        PUSH      _FPTRHI
                        LDS       _ACCA, TEST_RS232.Count
                        ST        -Y, _ACCA
                        .FRAME  1
                        LDI       _ACCA, 003h
                        ST        -Y, _ACCA
                        .FRAME  2
                        .FRAME  0
                        RCALL     SYSTEM.LCDXY
                        POP       _FPTRHI
                        POP       _FRAMEPTR

                        .LINE     181
                        PUSH      _FRAMEPTR
                        PUSH      _FPTRHI
                        LDI       _ACCA, 1 SHLB _DEVICE
                        OR        Flags, _ACCA
                        LDI       _ACCB, SYSTEM.LcdOut SHRB 1
                        LDI       _ACCA, SYSTEM.LcdOut SHRB 9
                        ST        -Y, _ACCA
                        ST        -Y, _ACCB
                        .FRAME  2
                        LDS       _ACCA, TEST_RS232.Receive
                        RCALL     SYSTEM.Char2Str
                        POP       _FPTRHI
                        POP       _FRAMEPTR
                        .FRAME  0
                        .LINE     182
                        LDS       _ACCA, TEST_RS232.Count
                        SUBI      _ACCA, -001h AND 0FFh
                        STS       TEST_RS232.COUNT, _ACCA
                        .LINE     183
                        LDS       _ACCA, TEST_RS232.Count
                        CPI       _ACCA, 014h
                        LDI       _ACCA, 0h
                        BRNE      TEST_RS232._L0046
                        SER       _ACCA
TEST_RS232._L0046:
                        TST       _ACCA
                        .BRANCH   4,TEST_RS232._L0049
                        BRNE      TEST_RS232._L0049
                        .BRANCH   20,TEST_RS232._L0047
                        RJMP      TEST_RS232._L0047
TEST_RS232._L0049:
                        .BLOCK    183
                        .LINE     184
                        LDI       _ACCA, 003E8h SHRB 8
                        LDI       _ACCB, 003E8h AND 0FFh
                        .FRAME  0
                        RCALL     SYSTEM.MDELAY

                        .LINE     185
                        PUSH      _FRAMEPTR
                        PUSH      _FPTRHI
                        LDI       _ACCA, 000h
                        ST        -Y, _ACCA
                        .FRAME  1
                        LDI       _ACCA, 003h
                        ST        -Y, _ACCA
                        .FRAME  2
                        .FRAME  0
                        RCALL     SYSTEM.LCDXY
                        POP       _FPTRHI
                        POP       _FRAMEPTR

                        .LINE     186
                        PUSH      _FRAMEPTR
                        PUSH      _FPTRHI
                        LDI       _ACCA, 1 SHLB _DEVICE
                        OR        Flags, _ACCA
                        LDI       _ACCB, SYSTEM.LcdOut SHRB 1
                        LDI       _ACCA, SYSTEM.LcdOut SHRB 9
                        ST        -Y, _ACCA
                        ST        -Y, _ACCB
                        .FRAME  2
                        LDI       _ACCCLO, $St_String8 AND 0FFh
                        LDI       _ACCCHI, $St_String8 SHRB 8
                        RCALL     SYSTEM.StrConst2Str
TEST_RS232._L0050:
                        POP       _FPTRHI
                        POP       _FRAMEPTR
                        .FRAME  0
                        .LINE     187
                        LDI       _ACCA, 000h
                        STS       TEST_RS232.COUNT, _ACCA
                        .ENDBLOCK 188
TEST_RS232._L0047:
TEST_RS232._L0048:
                        .ENDBLOCK 190
TEST_RS232._L0043:
TEST_RS232._L0044:
                        .ENDBLOCK 192
                        .LINE     192
                        .BRANCH   20,TEST_RS232._L0025
                        RJMP      TEST_RS232._L0025
TEST_RS232._L0026:
                        .ENDBLOCK 193

TEST_RS232.$_MAINEX:
                        .LINE     193
                        NOP
                        .LINE     193
                        .BRANCH   20,TEST_RS232.$_MAINEX
                        RJMP      TEST_RS232.$_MAINEX


                        .ENDFUNC  193

SYSTEM.$Main_stk        .EQU    001D7h          ; var iData  Process stack area
SYSTEM.$Main_stk_e      .EQU    00208h          ; var iData  Process stack area
SYSTEM.$Main_Frame      .EQU    00209h          ; var iData  Process stack area
SYSTEM.$Main_Frame_e    .EQU    0023Ah          ; var iData  Process stack area

                        ; ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        ; Initialisation and Library Routines
                        ; ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

                        .ENTRY
SYSTEM.RESET:
                        CLI
                        ; >> Stack Init [main process only] <<
                        LDI       _ACCA, 002h
                        LDI       _ACCB, 008h
                        OUT       sph, _ACCA
                        OUT       spl, _ACCB


                        ; >> Memory init <<
                        CLR       _ACCA
                        LDI       _ACCCLO, 16
                        LDI       _ACCCHI, 0
                        LDI       _ACCBLO, 0
                        LDI       _ACCBHI, 0
                        ADIW      _ACCCLO, 1
                        NOP
SYSTEM._L0051:
                        SBIW      _ACCCLO, 001h
                        BREQ      SYSTEM._L0053
SYSTEM._L0052:
                        ST        X+, _ACCA
                        RJMP      SYSTEM._L0051
SYSTEM._L0053:
                        LDI       _ACCBLO, 00100h AND 0FFh
                        LDI       _ACCBHI, 00100h SHRB 8
                        LDI       _ACCCLO, 00400h AND 0FFh
                        LDI       _ACCCHI, 00400h SHRB 8
                        ADIW      _ACCCLO, 1
                        NOP
SYSTEM._L0054:
                        SBIW      _ACCCLO, 001h
                        BREQ      SYSTEM._L0056
SYSTEM._L0055:
                        ST        X+, _ACCA
                        RJMP      SYSTEM._L0054
SYSTEM._L0056:
                        LDI       _FRAMEPTR, 0023Ah AND 0FFh
                        LDI       _FPTRHI, 0023Ah SHRB 8

                        CLI
                        LDI       _ACCA, 0FEH ROLB IntFlag
                        AND       Flags, _ACCA

                        ; ============ init structured constants ============
                        ; >> Hardware Init <<

                        ; >> SysTick init: 10msec <<
                        ; >> real SysTick (exact): 9.984 msec <<
                        LDI       _ACCA, 0B2h
                        STS       SysTickTime, _ACCA
                        OUT       tcnt0, _ACCA
                        LDI       _ACCA, 5
                        OUT       tccr0, _ACCA
                        LDI       _ACCA, 001h
                        STS       timsk0, _ACCA

                        ; >> LCD Init <<
                        LDS       _ACCA, 025h
                        CBR       _ACCA, 0F0h
                        STS       025h, _ACCA
                        LDS       _ACCA, 024h
                        SBR       _ACCA, 0F0h
                        STS       024h, _ACCA
                        LDS       _ACCALO, 025h
                        CBR       _ACCALO, 007h
                        STS       025h, _ACCALO
                        LDS       _ACCA, 024h
                        SBR       _ACCA, 007h
                        STS       024h, _ACCA
                        LDS       _ACCA, 025h
                        CBR       _ACCA, 0F0h
                        SBR       _ACCA, 30h
                        STS       025h, _ACCA
                        LDI       _ACCB, 16
                        CLR       _ACCA
                        RCALL     SYSTEM.MDELAY
                        LDS       _ACCALO, 025h
                        CBR       _ACCALO, 002h
                        SBR       _ACCALO, 004h
                        STS       025h, _ACCALO
                        NOP
                        NOP
                        NOP
                        NOP
                        NOP
                        NOP
                        CBR       _ACCALO, 004h
                        STS       025h, _ACCALO
                        LDI       _ACCB, 5
                        CLR       _ACCA
                        RCALL     SYSTEM.MDELAY
                        SBR       _ACCALO, 004h
                        STS       025h, _ACCALO
                        NOP
                        NOP
                        NOP
                        NOP
                        NOP
                        NOP
                        CBR       _ACCALO, 004h
                        STS       025h, _ACCALO
                        LDI       _ACCB, 1
                        CLR       _ACCA
                        RCALL     SYSTEM.MDELAY
                        SBR       _ACCALO, 004h
                        STS       025h, _ACCALO
                        NOP
                        NOP
                        NOP
                        NOP
                        NOP
                        NOP
                        CBR       _ACCALO, 004h
                        STS       025h, _ACCALO
                        LDS       _ACCA, 025h
                        CBR       _ACCA, 0F0h
                        SBR       _ACCA, 20h
                        STS       025h, _ACCA
                        LDI       _ACCB, 1
                        CLR       _ACCA
                        RCALL     SYSTEM.MDELAY
                        LDS       _ACCALO, 025h
                        SBR       _ACCALO, 004h
                        STS       025h, _ACCALO
                        NOP
                        NOP
                        NOP
                        NOP
                        NOP
                        NOP
                        CBR       _ACCALO, 004h
                        STS       025h, _ACCALO
                        LDI       _ACCB, 1
                        CLR       _ACCA
                        RCALL     SYSTEM.MDELAY
                        SBR       _ACCALO, 004h
                        STS       025h, _ACCALO
                        NOP
                        NOP
                        NOP
                        NOP
                        NOP
                        NOP
                        CBR       _ACCALO, 004h
                        STS       025h, _ACCALO
                        LDS       _ACCA, 025h
                        CBR       _ACCA, 0F0h
                        SBR       _ACCA, 80h
                        STS       025h, _ACCA
                        LDI       _ACCB, 1
                        CLR       _ACCA
                        RCALL     SYSTEM.MDELAY
                        LDS       _ACCALO, 025h
                        SBR       _ACCALO, 004h
                        STS       025h, _ACCALO
                        NOP
                        NOP
                        NOP
                        NOP
                        NOP
                        NOP
                        CBR       _ACCALO, 004h
                        STS       025h, _ACCALO
                        LDI       _ACCA, 0Ch
                        RCALL     SYSTEM.LCDCTRL
                        LDI       _ACCA, 1
                        RCALL     SYSTEM.LCDCTRL
                        LDI       _ACCA, 6
                        RCALL     SYSTEM.LCDCTRL

                        ; >> ADC Init <<
                        LDI       _ACCA, 005h
                        STS       admux, _ACCA
                        LDI       _ACCA ,0C7h
                        STS       adcsr, _ACCA

                        ; >> SERPORT Init <<
                        ; >> Baudrate 9600Baud <<
                        
                        ; percent Baudrate error : >> 0.160% <<
                        LDI       _ACCA, 018h
                        STS       ucr1, _ACCA
                        LDI       _ACCA, 033h
                        STS       ubrr1, _ACCA
                        LDI       _ACCA, 000h
                        STS       ubrrh, _ACCA
                        LDI       _ACCA, 0
                        STS       _RXINP, _ACCA
                        STS       _RXOUTP, _ACCA
                        STS       _RXCOUNT, _ACCA
                        LDS       _ACCA, ucr1
                        SBR       _ACCA, 80h
                        STS       ucr1, _ACCA
                        LDI       _ACCA, 0
                        STS       _TXINP, _ACCA
                        STS       _TXOUTP, _ACCA
                        STS       _TXCOUNT, _ACCA
                        LDI       _ACCA, 006h
                        STS       ucsrc, _ACCA
                        LDS       _ACCA, UDR1

                        CLR       Flags
                        CLR       Flags2

                        ; ============ Start User Main Program ============

                        .DEB      MAINENTRY
                        RJMP      TEST_RS232.$_Main

                        ; ============ Interrupt Service ============

SYSTEM.$INTERRUPT_TIMER0:
                        .DEB      SYSTICKENTRY
                        PUSH      _ACCCLO
                        PUSH      _ACCCHI
                        PUSH      _ACCB
                        PUSH      _ACCA
                        IN        _ACCA, SREG
                        PUSH      _ACCA
                        LDS       _ACCA, SysTickTime
                        IN        _ACCB, tcnt0
                        ADD       _ACCA, _ACCB
                        OUT       tcnt0, _ACCA
                        LDI       _ACCA, 0FEH ROLB IntFlag
                        AND       Flags, _ACCA
                        LDS       _ACCB, adcl
                        LDS       _ACCA, adch
                        STS       _ADCBUFF, _ACCB
                        STS       _ADCBUFF+1, _ACCA
                        ;
                        LDI       _ACCA, 1 SHLB IntFlag
                        OR        Flags, _ACCA
                        LDS       _ACCA, adcsr
                        SBR       _ACCA, 40h
                        STS       adcsr, _ACCA
                        ;
                        POP       _ACCA
                        OUT       SREG, _ACCA
                        POP       _ACCA
                        POP       _ACCB
                        POP       _ACCCHI
                        POP       _ACCCLO
                        .DEB      SYSTICKEXIT
                        RETI

SYSTEM.$INTERRUPT_TXEMPTY:
SYSTEM.$INTERRUPT_UDRE:
                        PUSH      _ACCCLO
                        PUSH      _ACCCHI
                        PUSH      _ACCB
                        PUSH      _ACCA
                        IN        _ACCA, SREG
                        PUSH      _ACCA
                        LDS       _ACCA, _TXCOUNT
                        TST       _ACCA
                        BRNE      SYSTEM._L0059
SYSTEM._L0063:
                        LDS       _ACCA, ucr1
                        CBR       _ACCA, 20h
                        STS       ucr1, _ACCA
                        RJMP      SYSTEM._L0061
SYSTEM._L0059:
                        LDS       _ACCB, _TXOUTP
                        CLR       _ACCA
                        LDI       _ACCCLO, _TXBUFF AND 0FFh
                        LDI       _ACCCHI, _TXBUFF SHRB 8
                        ADD       _ACCCLO, _ACCB
                        ADC       _ACCCHI, _ACCA
                        LD        _ACCA, Z
                        STS       UDR1, _ACCA
                        LDS       _ACCA, _TXCOUNT
                        DEC       _ACCA
                        STS       _TXCOUNT, _ACCA
                        BRNE      SYSTEM._L0062
                        LDS       _ACCA, ucr1
                        CBR       _ACCA, 20h
                        STS       ucr1, _ACCA
SYSTEM._L0062:
                        INC       _ACCB
                        CPI       _ACCB, 100
                        BRNE      SYSTEM._L0060
                        CLR       _ACCB
SYSTEM._L0060:
                        STS       _TXOUTP, _ACCB
SYSTEM._L0061:
                        POP       _ACCA
                        OUT       SREG, _ACCA
                        POP       _ACCA
                        POP       _ACCB
                        POP       _ACCCHI
                        POP       _ACCCLO
                        RETI

SYSTEM.$INTERRUPT_RXRDY:
                        PUSH      _ACCCLO
                        PUSH      _ACCCHI
                        PUSH      _ACCB
                        PUSH      _ACCA
                        IN        _ACCA, SREG
                        PUSH      _ACCA
SYSTEM._L0069:
                        LDS       _ACCA, _RXCOUNT
                        CPI       _ACCA, 100
                        BRNE      SYSTEM._L0064
                        LDS       _ACCB, UDR1
                        RJMP      SYSTEM._L0066
SYSTEM._L0064:
                        LDS       _ACCA, UDR1
                        PUSH      _ACCA
                        CLR       _ACCA
                        LDS       _ACCB, _RXINP
                        LDI       _ACCCLO, _RXBUFF AND 0FFh
                        LDI       _ACCCHI, _RXBUFF SHRB 8
                        ADD       _ACCCLO, _ACCB
                        ADC       _ACCCHI, _ACCA
                        POP       _ACCA
                        ST        Z, _ACCA
                        LDS       _ACCA, _RXCOUNT
                        INC       _ACCA
                        STS       _RXCOUNT, _ACCA
                        INC       _ACCB
                        CPI       _ACCB, 100
                        BRNE      SYSTEM._L0065
                        CLR       _ACCB
SYSTEM._L0065:
                        STS       _RXINP, _ACCB
                        LDS       _ACCB, usr1
                        SBRC      _ACCB, 7
                        RJMP      SYSTEM._L0069
SYSTEM._L0066:
SYSTEM._L0071:
                        POP       _ACCA
                        OUT       SREG, _ACCA
                        POP       _ACCA
                        POP       _ACCB
                        POP       _ACCCHI
                        POP       _ACCCLO
                        RETI


                        ; ============ Library ============

                        .DEB      LCDOUT
SYSTEM.LCDOUT:
                        PUSH      _ACCA
                        RCALL     SYSTEM.LCDWAIT
                        LDS       _ACCA, 024h
                        SBR       _ACCA, 0F0h
                        STS       024h, _ACCA
                        LDS       _ACCA, 025h
                        CBR       _ACCA, 007h
                        SBR       _ACCA, 001h
                        STS       025h, _ACCA
                        RJMP      SYSTEM.LCDOUTX
                        .DEB      LCDCTRL
SYSTEM.LCDCTRL:
                        PUSH      _ACCA
                        RCALL     SYSTEM.LCDWAIT
                        LDS       _ACCA, 024h
                        SBR       _ACCA, 0F0h
                        STS       024h, _ACCA
                        LDS       _ACCA, 025h
                        CBR       _ACCA, 007h
                        STS       025h, _ACCA
SYSTEM.LCDOUTX:
                        POP       _ACCA
                        PUSH      _ACCA
                        SWAP      _ACCA
                        ANDI      _ACCA, 0Fh
                        LDI       _ACCAHI, 4
                        RCALL     SYSTEM._LCDrol
                        LDS       _ACCB, 025h
                        CBR       _ACCB, 0F0h
                        OR        _ACCA, _ACCB
                        STS       025h, _ACCA
                        LDS       _ACCB, 025h
                        NOP
                        NOP
                        NOP
                        NOP
                        NOP
                        NOP
                        SBR       _ACCB, 004h
                        STS       025h, _ACCB
                        NOP
                        NOP
                        NOP
                        NOP
                        NOP
                        NOP
                        CBR       _ACCB, 004h
                        STS       025h, _ACCB
                        NOP
                        NOP
                        NOP
                        NOP
                        NOP
                        NOP
                        POP       _ACCA
                        ANDI      _ACCA, 0Fh
                        LDI       _ACCAHI, 4
                        RCALL     SYSTEM._LCDrol
                        LDS       _ACCAHI, 025h
                        CBR       _ACCAHI, 0F0h
                        OR        _ACCA, _ACCAHI
                        STS       025h, _ACCA
                        NOP
                        NOP
                        NOP
                        NOP
                        NOP
                        NOP
                        LDS       _ACCB, 025h
                        SBR       _ACCB, 004h
                        STS       025h, _ACCB
                        NOP
                        NOP
                        NOP
                        NOP
                        NOP
                        NOP
                        CBR       _ACCB, 004h
                        STS       025h, _ACCB
                        RET

SYSTEM._LCDrol:
                        TST       _ACCAHI
                        BREQ       SYSTEM._L0073
                        CLC
SYSTEM._L0072:
                        ROL       _ACCA
                        DEC       _ACCAHI
                        BRNE       SYSTEM._L0072
SYSTEM._L0073:
                        RET

SYSTEM.LCDINP:
                        RCALL     SYSTEM.LCDWAIT
                        LDS       _ACCA, 024h
                        CBR       _ACCA, 0F0h
                        STS       024h, _ACCA
                        LDS       _ACCB, 025h
                        CBR       _ACCB, 007h
                        SBR       _ACCB, 001h + 002h
                        STS       025h, _ACCB
                        CLT
                        BLD       Flags, _WAITLCD
                        RJMP      SYSTEM.LCDINPX

SYSTEM._LCDror:
                        TST       _ACCAHI
                        BREQ       SYSTEM._L0075
                        CLC
SYSTEM._L0074:
                        ROR       _ACCA
                        DEC       _ACCAHI
                        BRNE       SYSTEM._L0074
SYSTEM._L0075:
                        RET

SYSTEM.LCDWAIT:
                        LDI       _ACCCLO, 00140h AND 0FFh
                        LDI       _ACCCHI, 00140h SHRB 8
                        SET
                        BLD       Flags, _WAITLCD
                        RJMP      SYSTEM.LCDSTAT1
SYSTEM.LCDSTAT:
                        CLT
                        BLD       Flags, _WAITLCD
SYSTEM.LCDSTAT1:
                        LDS       _ACCA, 024h
                        CBR       _ACCA, 0F0h
                        STS       024h, _ACCA
                        LDS       _ACCALO, 025h
                        CBR       _ACCALO, 007h
                        STS       025h, _ACCALO
                        NOP
                        NOP
                        NOP
                        NOP
                        NOP
                        NOP
                        SBR       _ACCALO, 002h
                        STS       025h, _ACCALO
SYSTEM.LCDINPX:
                        NOP
                        NOP
                        NOP
                        NOP
                        NOP
                        NOP
                        LDS       _ACCALO, 025h
                        SBR       _ACCALO, 004h
                        STS       025h, _ACCALO
                        NOP
                        NOP
                        NOP
                        NOP
                        NOP
                        NOP
                        LDS       _ACCA, 023h
                        ANDI      _ACCA, 0F0h
                        PUSH      _ACCA
                        CBR       _ACCALO, 004h
                        STS       025h, _ACCALO
                        NOP
                        NOP
                        NOP
                        NOP
                        NOP
                        NOP
                        SBR       _ACCALO, 004h
                        STS       025h, _ACCALO
                        NOP
                        NOP
                        NOP
                        NOP
                        NOP
                        NOP
                        LDS       _ACCA, 023h
                        ANDI      _ACCA, 0F0h
                        CBR       _ACCALO, 004h
                        STS       025h, _ACCALO
                        LDI       _ACCAHI, 4
                        RCALL     SYSTEM._LCDror
                        MOV       _ACCB, _ACCA
                        POP       _ACCA
                        LDI       _ACCAHI, 0
                        RCALL     SYSTEM._LCDrol
                        OR        _ACCA, _ACCB
                        BST       Flags, _WAITLCD
                        BRTS      SYSTEM._L0076
                        .DEB      LCDINP
                        RET
SYSTEM._L0076:
                        SBIW      _ACCCLO, 1
                        BREQ      SYSTEM._L0077
                        ROL       _ACCA
                        BRCC      SYSTEM._L0078
                        RJMP      SYSTEM.LCDINPX
SYSTEM._L0078:
                        RET
SYSTEM._L0077:
                        SER       _ACCA
                        RET

SYSTEM.LCDON:
                        LDI       _ACCA, 0FFh
                        LDI       _ACCB, 0FFh
                        RJMP      SYSTEM._L0079
SYSTEM.LCDCURSOR:
                        POP       _ACCCHI
                        POP       _ACCCLO
                        POP       _ACCA
                        POP       _ACCB
                        PUSH      _ACCCLO
                        PUSH      _ACCCHI
SYSTEM._L0079:
                        TST       _ACCA
                        BRNE       SYSTEM._L0080
                        LDI       _ACCA, 0Ch
                        RJMP      SYSTEM._L0081

SYSTEM._L0080:
                        LDI       _ACCA, 0Dh
SYSTEM._L0081:
                        TST       _ACCB
                        BREQ       SYSTEM._L0082
                        ORI       _ACCA, 2
SYSTEM._L0082:
                        RCALL     SYSTEM.LCDCTRL
                        RET

SYSTEM.LCDXY:
                        LDD       _ACCA, Y+000h
                        LDD       _ACCB, Y+001h
                        CPI       _ACCA, 0
                        BRNE       SYSTEM._L0083
                        LDI       _ACCA, 080h
                        RJMP      SYSTEM._L0087

SYSTEM._L0083:
                        CPI       _ACCA, 1
                        BRNE       SYSTEM._L0084
                        LDI       _ACCA, 0C0h
                        RJMP      SYSTEM._L0087

SYSTEM._L0084:
                        CPI       _ACCA, 2
                        BRNE       SYSTEM._L0085
                        LDI       _ACCA, 094h
                        RJMP      SYSTEM._L0087

SYSTEM._L0085:
                        CPI       _ACCA, 3
                        BRNE       SYSTEM._L0086
                        LDI       _ACCA, 0D4h
                        RJMP      SYSTEM._L0087

SYSTEM._L0086:
                        LDI       _ACCA, 080h
SYSTEM._L0087:
                        ADD       _ACCA, _ACCB
                        RCALL     SYSTEM.LCDCTRL
                        RET

SYSTEM.LCDCLR:
                        LDI       _ACCA, 01h
                        RCALL     SYSTEM.LCDCTRL
                        RET

SYSTEM.LCDCLRLINE:
                        CPI       _ACCA, 0
                        BRNE       SYSTEM._L0088
                        LDI       _ACCA, 080h
                        RJMP      SYSTEM._L0092

SYSTEM._L0088:
                        CPI       _ACCA, 1
                        BRNE       SYSTEM._L0089
                        LDI       _ACCA, 0C0h
                        RJMP      SYSTEM._L0092

SYSTEM._L0089:
                        CPI       _ACCA, 2
                        BRNE       SYSTEM._L0090
                        LDI       _ACCA, 094h
                        RJMP      SYSTEM._L0092

SYSTEM._L0090:
                        CPI       _ACCA, 3
                        BRNE       SYSTEM._L0091
                        LDI       _ACCA, 0D4h
                        RJMP      SYSTEM._L0092

SYSTEM._L0091:
                        RET
SYSTEM._L0092:
                        PUSH      _ACCA
                        RCALL     SYSTEM.LCDCTRL
                        LDI       _ACCA, 014h
SYSTEM._L0093:
                        PUSH      _ACCA
                        LDI       _ACCA, 20h
                        RCALL     SYSTEM.LCDOUT
                        POP       _ACCA
                        DEC       _ACCA
                        BRNE       SYSTEM._L0093
                        POP       _ACCA
                        RCALL     SYSTEM.LCDCTRL
                        RET

SYSTEM.SERINP:
SYSTEM.SERINP1:
SYSTEM._L0094:
                        LDS       _ACCA, _RXCOUNT
                        TST       _ACCA
                        BREQ      SYSTEM._L0094
                        LDS       _ACCB, _RXOUTP
                        CLR       _ACCA
                        LDI       _ACCCLO, _RXBUFF AND 0FFh
                        LDI       _ACCCHI, _RXBUFF SHRB 8
                        ADD       _ACCCLO, _ACCB
                        ADC       _ACCCHI, _ACCA
                        LD        _ACCA, Z
                        CLI
                        LDS       _ACCCLO, _RXCOUNT
                        DEC       _ACCCLO
                        STS       _RXCOUNT, _ACCCLO
                        SBRC      Flags, IntFlag
                        SEI
                        LDS       _ACCB, _RXOUTP
                        INC       _ACCB
                        CPI       _ACCB, 100
                        BRNE      SYSTEM._L0095
                        CLR       _ACCB
SYSTEM._L0095:
                        STS       _RXOUTP, _ACCB
                        RET

SYSTEM.SERSTAT:
SYSTEM.SERSTAT1:
                        CLR       _ACCA
                        LDS       _ACCB, _RXCOUNT
                        TST       _ACCB
                        BREQ      SYSTEM._L0100
                        COM       _ACCA
SYSTEM._L0100:
                        RET

SYSTEM.SEROUT:
SYSTEM.SEROUT1:
SYSTEM._L0104:
                        LDS       _ACCB, _TXCOUNT
                        CPI       _ACCB, 100
                        BREQ      SYSTEM._L0104
                        CLI
                        LDS       _ACCB, _TXINP
                        LDI       _ACCCLO, _TXBUFF AND 0FFh
                        LDI       _ACCCHI, _TXBUFF SHRB 8
                        ADD       _ACCCLO, _ACCB
                        CLR       _ACCB
                        ADC       _ACCCHI, _ACCB
                        ST        Z, _ACCA
                        LDS       _ACCB, _TXCOUNT
                        INC       _ACCB
                        STS       _TXCOUNT, _ACCB
                        LDS       _ACCB, _TXINP
                        INC       _ACCB
                        CPI       _ACCB, 100
                        BRNE      SYSTEM._L0105
                        CLR       _ACCB
SYSTEM._L0105:
                        STS       _TXINP, _ACCB
                        LDS       _ACCB, ucr1
                        SBR       _ACCB, 20h
                        STS       ucr1, _ACCB
                        SBRC      Flags, IntFlag
                        SEI
                        RET


SYSTEM.MDELAY:
                        .DEB      DEBdelay
                        MOVW      _ACCDLO, _ACCB
                        CLR       _ACCA
                        CP        _ACCDLO, _ACCA
                        CPC       _ACCDHI, _ACCA
                        BREQ      SYSTEM.MDELAY3
SYSTEM.MDELAY1:
                        LDI       _ACCB, 0063Dh AND 0FFh
                        LDI       _ACCA, 0063Dh SHRB 8
SYSTEM.MDELAY2:
                        SUBI      _ACCB, 001h
                        SBCI      _ACCA, 000h
                        NOP
                        BRNE      SYSTEM.MDELAY2
                        SUBI      _ACCDLO, 001h
                        SBCI      _ACCDHI, 000h
                        BRNE      SYSTEM.MDELAY1
SYSTEM.MDELAY3:
                        RET

SYSTEM.UDELAY:
                        TST       _ACCA
                        BREQ      SYSTEM.UDELAY3
SYSTEM.UDELAY1:
                        LDI       _ACCB, 00013h AND 0FFh
SYSTEM.UDELAY2:
                        DEC       _ACCB
                        NOP
                        BRNE      SYSTEM.UDELAY2
                        DEC       _ACCA
                        BRNE      SYSTEM.UDELAY1
SYSTEM.UDELAY3:
                        RET

SYSTEM.BlockCopyC:
SYSTEM._L0109:
                        SUBI      _ACCALO, 001h
                        SBCI      _ACCAHI, 000h
                        BRCS      SYSTEM._L0110
                        LD        _ACCA, Z+
                        ST        X+, _ACCA
                        RJMP      SYSTEM._L0109
SYSTEM._L0110:
                        RET


SYSTEM.StrConst2Str:
                        LPM       _ACCBHI, Z+
                        TST       _ACCBHI
                        BREQ      SYSTEM._L0112
SYSTEM.StrConst2StrPart:
SYSTEM._L0111:
                        LPM      _ACCA, Z+
                        RCALL     SYSTEM.Char2Str
                        DEC       _ACCBHI
                        BRNE      SYSTEM._L0111
SYSTEM._L0112:
                        RET

SYSTEM._B2STR:
                        PUSH      _ACCBLO
                        PUSH      _ACCBHI
                        LD        _ACCA, X+
                        LD        _ACCB, X+
                        LD        _ACCELO, X+
                        MOVW      _ACCBLO, _ACCCLO
                        ST        -Y, _ACCELO
                        ST        -Y, _ACCB
                        ST        -Y, _ACCA
                        TST       _ACCFLO
                        BREQ       SYSTEM._B2STR_NM
                        TST       _ACCALO
                        BREQ       SYSTEM._B2STR_NM
                        DEC       _ACCALO
SYSTEM._B2STR_NM:
                        MOV       _ACCELO, _ACCDHI
                        MOV       _ACCEHI, _ACCDHI
                        LSL       _ACCEHI
                        DEC       _ACCEHI
                        CLR       _ACCB
                        ADD       XL, _ACCEHI
                        ADC       XH, _ACCB
SYSTEM._B2STR_0:
                        LD        _ACCA, -X
                        TST       _ACCA
                        BRNE       SYSTEM._B2STR_1
                        SBIW      XL, 1
                        DEC       _ACCELO
                        BRNE       SYSTEM._B2STR_0
SYSTEM._B2STR_1:
                        TST       _ACCELO
                        BRNE       SYSTEM._B2STR_2
                        ADIW      XL, 1
                        INC       _ACCELO
SYSTEM._B2STR_2:
                        ADIW      XL, 2
                        TST       _ACCAHI
                        BRNE       SYSTEM._B2STR_PNT
                        TST       _ACCALO
                        BREQ       SYSTEM._B2STR_3
                        RJMP       SYSTEM._B2STR_FILL
SYSTEM._B2STR_3:
                        RJMP       SYSTEM._B2STR_WR
SYSTEM._B2STR_PNT:
                        TST       _ACCALO
                        BREQ       SYSTEM._B2STR_PNTE0
                        DEC       _ACCALO
SYSTEM._B2STR_PNTE0:
                        CLR       _ACCB
                        MOVW      _ACCBLO, _ACCCLO
                        CP        _ACCAHI, _ACCDHI
                        BRCC       SYSTEM._B2STR_PNTGT
                        MOV       _ACCEHI, _ACCAHI
                        LSL       _ACCEHI
                        ADD       XL, _ACCEHI
                        ADC       XH, _ACCB
                        LDI       _ACCA, DECIMALSEP
                        ST        -X, _ACCA
                        CP        _ACCAHI, _ACCELO
                        BRCS       SYSTEM._B2STR_PNTE1
                        MOV       _ACCELO, _ACCAHI
                        INC       _ACCELO
SYSTEM._B2STR_PNTE1:
                        MOV       _ACCEHI, _ACCELO
                        LSL       _ACCEHI
                        MOVW      _ACCBLO, _ACCCLO
                        ADD       XL, _ACCEHI
                        ADC       XH, _ACCB
                        RJMP       SYSTEM._B2STR_FILL
SYSTEM._B2STR_PNTGT:
                        ADD       XL, _ACCEHI
                        ADC       XH, _ACCB
                        ADIW      XL, 1
                        MOV       _ACCEHI, _ACCAHI
                        ADDI      _ACCEHI, 2
                        CP        _ACCALO, _ACCEHI
                        BRCS       SYSTEM._B2STR_PNTG0
                        MOV       _ACCB, _ACCALO
                        SUB       _ACCB, _ACCEHI
                        INC       _ACCB
                        RJMP       SYSTEM._B2STR_PNTG1
SYSTEM._B2STR_PNTG0:
                        CLR       _ACCB
SYSTEM._B2STR_PNTG1:
                        MOV       _ACCALO, _ACCB
SYSTEM._B2STR_PNTG2:
                        TST       _ACCB
                        BREQ       SYSTEM._B2STR_PNTG3
                        MOV       _ACCA, _ACCDLO
                        RCALL     SYSTEM.Char2Str
                        DEC       _ACCB
                        RJMP       SYSTEM._B2STR_PNTG2
SYSTEM._B2STR_PNTG3:
                        MOV       _ACCEHI, _ACCAHI
                        SUB       _ACCEHI, _ACCDHI
                        MOV       _ACCELO, _ACCDHI
                        ADD       _ACCALO, _ACCEHI
                        TST       _ACCFLO
                        BREQ       SYSTEM._B2STR_PNTG4
                        MOV       _ACCA, _ACCFLO
                        RCALL     SYSTEM.Char2Str
                        CLR       _ACCFLO
                        INC       _ACCALO
SYSTEM._B2STR_PNTG4:
                        ADDI      _ACCALO, 2
                        LDI       _ACCA, 30h
                        RCALL     SYSTEM.Char2Str
                        LDI       _ACCA, DECIMALSEP
                        RCALL     SYSTEM.Char2Str
                        LDI       _ACCA, 30h
SYSTEM._B2STR_PNTG5:
                        TST       _ACCEHI
                        BREQ       SYSTEM._B2STR_WR
                        RCALL     SYSTEM.Char2Str
                        DEC       _ACCEHI
                        RJMP       SYSTEM._B2STR_PNTG5
SYSTEM._B2STR_FILL:
                        CP        _ACCELO, _ACCALO
                        BRCS       SYSTEM._B2STR_F0
                        CLR       _ACCALO
                        RJMP       SYSTEM._B2STR_WR
SYSTEM._B2STR_F0:
                        SUB       _ACCALO, _ACCELO
                        MOV       _ACCB, _ACCALO
                        BST       Flags2, _F64StrFrac
                        BRTC      SYSTEM._B2STR_F1
                        LDD       _ACCELO, Y+32
SYSTEM._B2STR_F3:
                        CP        _ACCELO, _ACCB
                        BRCC      SYSTEM._L0113
                        SUB       _ACCB, _ACCELO
SYSTEM._L0113:
                        SUB       _ACCELO, _ACCB
                        STD       Y+32, _ACCELO
SYSTEM._B2STR_F1:
                        MOV       _ACCA, _ACCDLO
                        RCALL     SYSTEM.Char2Str
                        DEC       _ACCB
                        BRNE       SYSTEM._B2STR_F1
SYSTEM._B2STR_WR:
                        BST       Flags2, _F64StrFrac
                        BRTC      SYSTEM._L0114
                        LDD       _ACCELO, Y+32
SYSTEM._B2STR_F2:
                        TST       _ACCELO
                        BREQ       SYSTEM._B2STR_WR2
SYSTEM._L0114:
                        TST       _ACCFLO
                        BREQ       SYSTEM._B2STR_WR0
                        MOV       _ACCA, _ACCFLO
                        RCALL     SYSTEM.Char2Str
SYSTEM._B2STR_WR0:
                        LD        _ACCA, -X
                        TST       _ACCA
                        BREQ       SYSTEM._B2STR_WR1
                        RCALL     SYSTEM.Char2Str
SYSTEM._B2STR_WR1:
                        LD        _ACCA, -X
                        ORI       _ACCA, 30h
                        RCALL     SYSTEM.Char2Str
                        DEC       _ACCELO
                        BRNE       SYSTEM._B2STR_WR0
SYSTEM._B2STR_WR2:
                        BST       Flags2, _F64StrInt
                        BRTC      SYSTEM._L0115
                        LDD       _ACCA, Y+32
SYSTEM._B2STR_F4:
                        TST       _ACCA
                        BREQ       SYSTEM._L0115
                        LDI       _ACCA, DECIMALSEP
                        RCALL     SYSTEM.Char2Str
SYSTEM._L0115:
                        POP       _ACCBHI
                        POP       _ACCBLO
                        LDD        _ACCA, Y+0
                        ST         X+, _ACCA
                        LDD        _ACCA, Y+1
                        ST         X+, _ACCA
                        LDD        _ACCA, Y+2
                        ST         X+, _ACCA
                        RET


SYSTEM.Int2Str:
                        PUSH      _FRAMEPTR
                        PUSH      _FPTRHI
                        SBIW      _FRAMEPTR, 10
                        LDD       XL, Y+13
                        LDD       XH, Y+14
                        CLR       _ACCFLO
                        BST       Flags, _SIGN
                        BRTC      SYSTEM._cv16_0
                        TST       XH
                        BRPL      SYSTEM._cv16_0
                        LDI       _ACCFLO, 2Dh
                        SUBI      XL, 01h
                        SBCI      XH, 00h
                        COM       XL
                        COM       XH
SYSTEM._cv16_0:
                        PUSH      _ACCFLO
                        mov       r24, XH
                        swap      r24
                        andi      r24, 0Fh
                        subi      r24, -0F0h and 0FFh
                        mov       r19, r24
                        add       r19, r24
                        subi      r24, -0E2h and 0ffh
                        mov       r18, r24
                        subi      r24, -32h and 0ffh
                        mov       r16, r24
                        mov       r24, XH
                        andi      r24, 0Fh
                        add       r18, r24
                        add       r18, r24
                        add       r16, r24
                        subi      r24, -0E9h and $ff
                        mov       r17, r24
                        add       r17, r24
                        add       r17, r24
                        mov       r24, XL
                        swap      r24
                        andi      r24, 0Fh
                        add       r17, r24
                        add       r16, r24
                        rol       r17
                        rol       r16
                        com       r16
                        clc
                        rol       r16
                        mov       r24, XL
                        andi      r24, 0Fh
                        add       r16, r24
                        rol       r19
                        ldi       r24, 07h
                        mov       r20, r24
                        ldi       r24, 0Ah
SYSTEM._cv16_1:
                        add       r16,r24
                        dec       r17
                        brcc      SYSTEM._cv16_1
SYSTEM._cv16_2:
                        add       r17, r24
                        dec       r18
                        brcc      SYSTEM._cv16_2
SYSTEM._cv16_3:
                        add       r18, r24
                        dec       r19
                        brcc      SYSTEM._cv16_3
SYSTEM._cv16_4:
                        add       r19, r24
                        dec       r20
                        brcc      SYSTEM._cv16_4
SYSTEM._cv16_5:
                        MOVW      _ACCBLO, _FRAMEPTR
                        clr       ZH
                        ldi       ZL, 16
                        ldi       r25, 5
                        ldi       r23, 0
SYSTEM._cv16_6:
                        ld        r24, Z+
                        st        X+, r24
                        st        X+, r23
                        dec       r25
                        brne      SYSTEM._cv16_6
                        LDD       _ACCALO, Y+12
                        LDD       _ACCAHI, Y+11
                        LDD       _ACCDLO, Y+10
                        LDI       _ACCDHI, 5
                        POP       _ACCFLO
                        MOVW      _ACCCLO, _FRAMEPTR
                        MOVW      _ACCBLO, _FRAMEPTR
                        ADIW      XL, 15
                        RCALL     SYSTEM._B2STR
                        POP       _FPTRHI
                        POP       _FRAMEPTR
                        RET


SYSTEM.Char2Str:
                        PUSH      _ACCCLO
                        PUSH      _ACCCHI
                        BST       Flags, _DEVICE
                        BRTS      SYSTEM._L0119
                        PUSH      _ACCA
                        LDD       _ACCCLO, Y+001h
                        LDD       _ACCCHI, Y+002h
                        LDD       _ACCA, Y+000h
                        TST       _ACCA
                        BRNE      SYSTEM._L0116
                        POP       _ACCA
                        SET
                        BLD       Flags, _ERRFLAG
                        POP       _ACCCHI
                        POP       _ACCCLO
                        RET
SYSTEM._L0116:
                        DEC       _ACCA
                        STD       Y+000h, _ACCA
                        POP       _ACCA
                        ST        Z+, _ACCA
                        STD       Y+002h, _ACCCHI
                        STD       Y+001h, _ACCCLO
                        POP       _ACCCHI
                        POP       _ACCCLO
                        RET
SYSTEM._L0119:
                        LDD       _ACCCLO, Y+000h
                        LDD       _ACCCHI, Y+001h
                        PUSH      _ACCA
                        PUSH      _ACCB
                        PUSH      _ACCALO
                        PUSH      _ACCAHI
                        PUSH      _ACCBLO
                        PUSH      _ACCBHI
                        PUSH      _ACCELO
                        PUSH      _ACCEHI
                        PUSH      _ACCDLO
                        PUSH      _ACCDHI
                        PUSH      _ACCFLO
                        PUSH      _ACCFHI
                        ICALL
                        POP       _ACCFHI
                        POP       _ACCFLO
                        POP       _ACCDHI
                        POP       _ACCDLO
                        POP       _ACCEHI
                        POP       _ACCELO
                        POP       _ACCBHI
                        POP       _ACCBLO
                        POP       _ACCAHI
                        POP       _ACCALO
                        POP       _ACCB
                        POP       _ACCA
                        POP       _ACCCHI
                        POP       _ACCCLO
                        RET

SYSTEM.FTRUNCX:
                        PUSH      _ACCELO
                        PUSH      _ACCEHI
                        MOV       _ACCEHI, _ACCAHI
                        MOV       _ACCELO, _ACCALO
                        ROL       _ACCELO
                        ROL       _ACCEHI
                        SUBI      _ACCEHI, 127
                        BRCC      SYSTEM._L0120
                        POP       _ACCEHI
                        POP       _ACCELO
                        CLR       _ACCA
                        CLR       _ACCB
                        CLR       _ACCAHI
                        CLR       _ACCALO
                        RET
SYSTEM._L0120:
                        ORI       _ACCALO, 080h
                        MOV       _ACCELO, _ACCAHI
                        CLR       _ACCAHI
                        CPI       _ACCEHI, 24
                        BRSH      SYSTEM._L0122
                        SUBI      _ACCEHI, 23
                        NEG       _ACCEHI
SYSTEM._L0121:
                        BREQ      SYSTEM._L0124
                        LSR       _ACCAHI
                        ROR       _ACCALO
                        ROR       _ACCA
                        ROR       _ACCB
                        DEC       _ACCEHI
                        RJMP      SYSTEM._L0121
SYSTEM._L0122:
                        SUBI      _ACCEHI, 23
SYSTEM._L0123:
                        BREQ      SYSTEM._L0124
                        LSL       _ACCB
                        ROL       _ACCA
                        ROL       _ACCALO
                        ROL       _ACCAHI
                        DEC       _ACCEHI
                        RJMP      SYSTEM._L0123
SYSTEM._L0124:
                        SBRS      _ACCELO, 7
                        RJMP      SYSTEM._L0125
                        SUBI      _ACCB, 01h
                        SBCI      _ACCA, 00h
                        SBCI      _ACCALO, 00h
                        SBCI      _ACCAHI, 00h
                        COM       _ACCB
                        COM       _ACCA
                        COM       _ACCAHI
                        COM       _ACCALO
SYSTEM._L0125:
                        POP       _ACCEHI
                        POP       _ACCELO
                        RET

SYSTEM.FENTIERx:
                        CPI       _ACCAHI, 0CFh
                        BRLO      SYSTEM._L0126
                        LDI       _ACCAHI, 080h
                        CLR       _ACCALO
                        CLR       _ACCA
                        CLR       _ACCB
                        RET
SYSTEM._L0126:
                        SBRC      _ACCAHI, 7
                        RJMP      SYSTEM._L0127
                        CPI       _ACCAHI, 04Fh
                        BRLO      SYSTEM._L0127
                        LDI       _ACCAHI, 07Fh
                        LDI       _ACCALO, 0FFh
                        LDI       _ACCA, 0FFh
                        LDI       _ACCB, 0FFh
                        RET
SYSTEM._L0127:
                        SBRS      _ACCAHI, 7
                        RJMP      SYSTEM.FTRUNCX
                        ANDI      _ACCAHI, 07Fh
                        RCALL     SYSTEM.FTRUNCX
                        SUBI      _ACCB, 01h
                        SBCI      _ACCA, 00h
                        SBCI      _ACCALO, 00h
                        SBCI      _ACCAHI, 00h
                        COM       _ACCALO
                        COM       _ACCAHI
                        COM       _ACCA
                        COM       _ACCB
                        RET


SYSTEM.HighF:
                        MOV       _ACCDLO, _ACCAHI
                        AND       _ACCDLO, _ACCCHI
                        ANDI      _ACCDLO, 080h
                        SBRS      _ACCAHI, 7
                        RJMP      SYSTEM._L0129
                        CBR       _ACCAHI, 080h
                        SBRS      _ACCDLO, 7
                        RJMP      SYSTEM._L0131
SYSTEM._L0129:
                        SBRS      _ACCCHI, 7
                        RJMP      SYSTEM._L0130
                        CBR       _ACCCHI, 080h
                        SBRS      _ACCDLO, 7
                        RJMP      SYSTEM._L0132
SYSTEM._L0130:
                        CP        _ACCAHI, _ACCCHI
                        BRLO      SYSTEM._L0131
                        BRNE      SYSTEM._L0132
                        CP        _ACCALO, _ACCCLO
                        BRLO      SYSTEM._L0131
                        BRNE      SYSTEM._L0132
                        CP        _ACCA, _ACCBHI
                        BRLO      SYSTEM._L0131
                        BRNE      SYSTEM._L0132
                        CP        _ACCB, _ACCBLO
                        BRLO      SYSTEM._L0131
                        BRNE      SYSTEM._L0132
                        RJMP      SYSTEM._L0136
SYSTEM._L0131:
                        SBRC      _ACCDLO, 7
                        RJMP      SYSTEM._L0134
SYSTEM._L0133:
                        BST       Flags, _NEGATIVE
                        BRTS      SYSTEM._L0135
                        MOVW      _ACCB, _ACCBLO
                        MOVW      _ACCALO, _ACCCLO
SYSTEM._L0135:
                        INC       _ACCDHI
                        RJMP      SYSTEM._L0136
SYSTEM._L0132:
                        SBRC      _ACCDLO, 7
                        RJMP      SYSTEM._L0133
SYSTEM._L0134:
                        DEC       _ACCDHI
SYSTEM._L0136:
                        OR        _ACCAHI, _ACCDLO
                        RET

SYSTEM.LIntToFloat:
                        TST       _ACCAHI
                        BRNE      SYSTEM._L0137
                        TST       _ACCALO
                        BRNE      SYSTEM._L0137
                        TST       _ACCA
                        BRNE      SYSTEM._L0137
                        TST       _ACCB
                        BRNE      SYSTEM._L0137
                        RET
SYSTEM._L0137:
                        CLR       _ACCBLO
                        SBRS      Flags, _SIGN
                        RJMP      SYSTEM._L0138
                        MOV       _ACCBLO, _ACCAHI
                        ANDI      _ACCBLO, 080h
                        TST       _ACCAHI
                        BRPL      SYSTEM._L0143
                        SUBI      _ACCB, 01h
                        SBCI      _ACCA, 00h
                        SBCI      _ACCALO, 00h
                        SBCI      _ACCAHI, 00h
                        COM       _ACCALO
                        COM       _ACCAHI
                        COM       _ACCA
                        COM       _ACCB
SYSTEM._L0143:
SYSTEM._L0138:
                        LDI       _ACCBHI, 150
SYSTEM._L0139:
                        TST       _ACCAHI
                        BREQ      SYSTEM._L0140
                        LSR       _ACCAHI
                        ROR       _ACCALO
                        ROR       _ACCA
                        ROR       _ACCB
                        INC       _ACCBHI
                        RJMP      SYSTEM._L0139
SYSTEM._L0140:
                        SBRC      _ACCALO, 7
                        RJMP      SYSTEM._L0141
                        LSL       _ACCB
                        ROL       _ACCA
                        ROL       _ACCALO
                        ROL       _ACCAHI
                        DEC       _ACCBHI
                        RJMP      SYSTEM._L0140
SYSTEM._L0141:
                        ANDI      _ACCALO, 07Fh
                        MOV       _ACCAHI, _ACCBHI
                        LSR       _ACCAHI
                        BRCC      SYSTEM._L0142
                        ORI       _ACCALO, 080h
SYSTEM._L0142:
                        OR        _ACCAHI, _ACCBLO
                        RET

SYSTEM.MulFloat:
                        MOVW      _ACCBLO, _ACCB
                        MOVW      _ACCCLO, _ACCALO
                        POP       _ACCA
                        POP       _ACCB
                        POP       _ACCEHI
                        POP       _ACCELO
                        POP       _ACCDHI
                        POP       _ACCDLO
                        PUSH      _ACCB
                        PUSH      _ACCA
SYSTEM.MulFloat_R:
                        TST       _ACCCHI
                        BREQ      SYSTEM._L0144
                        TST       _ACCEHI
                        BRNE      SYSTEM._L0145
SYSTEM._L0144:
                        CLR       _ACCB
                        CLR       _ACCA
                        CLR       _ACCALO
                        CLR       _ACCAHI
                        RET
SYSTEM._L0145:
                        MOV       _ACCAHI, _ACCCHI
                        EOR       _ACCAHI, _ACCEHI
                        ANDI      _ACCAHI, 080h
                        ROL       _ACCCLO
                        ROL       _ACCCHI
                        SEC
                        ROR       _ACCCLO
                        ROL       _ACCELO
                        ROL       _ACCEHI
                        SEC
                        ROR       _ACCELO
                        CLR       _ACCA
                        ADD       _ACCCHI, _ACCEHI
                        ADC       _ACCA, _ACCA
                        SUBI      _ACCCHI, 07Fh
                        SBCI      _ACCA, 00h
                        TST       _ACCA
                        BRNE      SYSTEM._L0146
                        CPI       _ACCCHI, 0FFh
                        BRLO      SYSTEM._L0147
SYSTEM._L0146:
                        SET
                        BLD       Flags, _ERRFLAG
                        ANDI      _ACCAHI, 080h
                        ORI       _ACCAHI, 07Eh
                        LDI       _ACCALO, 0FFh
                        LDI       _ACCB, 0FFh
                        LDI       _ACCA, 0FFh
                        RET
SYSTEM._L0147:
                        CPI       _ACCCHI, 01h
                        BRSH      SYSTEM._L0148
                        CLR       _ACCAHI
                        CLR       _ACCALO
                        CLR       _ACCB
                        CLR       _ACCA
                        SET
                        BLD       Flags, _ERRFLAG
                        RET
SYSTEM._L0148:
                        PUSH      _ACCAHI
                        PUSH      _ACCCHI
                        CLR       _ACCCHI
                        CLR       _ACCEHI
                        CLR       _ACCFHI
                        CLR       _ACCFLO
                        CLR       _ACCGHI
                        CLR       _ACCGLO
                        LSR       _ACCEHI
                        ROR       _ACCELO
                        ROR       _ACCDHI
                        ROR       _ACCDLO
                        LDI       _ACCA, 32
SYSTEM._L0149:
                        BRCC      SYSTEM._L0150
                        ADD       _ACCFLO, _ACCBLO
                        ADC       _ACCFHI, _ACCBHI
                        ADC       _ACCGLO, _ACCCLO
                        ADC       _ACCGHI, _ACCCHI
SYSTEM._L0150:
                        ROR       _ACCGHI
                        ROR       _ACCGLO
                        ROR       _ACCFHI
                        ROR       _ACCFLO
                        ROR       _ACCEHI
                        ROR       _ACCELO
                        ROR       _ACCDHI
                        ROR       _ACCDLO
                        DEC       _ACCA
                        BRNE      SYSTEM._L0149
                        LDI       _ACCALO, 23
SYSTEM._L0151:
                        LSR       _ACCGHI
                        ROR       _ACCGLO
                        ROR       _ACCFHI
                        ROR       _ACCFLO
                        ROR       _ACCEHI
                        ROR       _ACCELO
                        ROR       _ACCDHI
                        ROR       _ACCDLO
                        DEC       _ACCALO
                        BRNE      SYSTEM._L0151
                        MOV       _ACCB, _ACCDLO
                        MOV       _ACCA, _ACCDHI
                        MOV       _ACCALO, _ACCELO
                        MOV       _ACCAHI, _ACCEHI
                        POP       _ACCBHI
                        POP       _ACCGLO
                        TST       _ACCAHI
                        BREQ      SYSTEM._L0152
                        LSR       _ACCAHI
                        ROR       _ACCALO
                        ROR       _ACCA
                        ROR       _ACCB
                        INC       _ACCBHI
SYSTEM._L0152:
                        MOV       _ACCAHI, _ACCGLO
                        ROL       _ACCALO
                        LSR       _ACCBHI
                        ROR       _ACCALO
                        OR        _ACCAHI, _ACCBHI
                        RET

SYSTEM.AddFloat:
                        MOVW      _ACCBLO, _ACCB
                        MOVW      _ACCCLO, _ACCALO
                        POP       _ACCA
                        POP       _ACCB
                        POP       _ACCEHI
                        POP       _ACCELO
                        POP       _ACCDHI
                        POP       _ACCDLO
                        PUSH      _ACCB
                        PUSH      _ACCA
SYSTEM.AddFloat1:
                        MOV       _ACCA, _ACCCHI
                        ANDI      _ACCA, 07Fh
                        MOV       _ACCB, _ACCEHI
                        ANDI      _ACCB, 07Fh
                        CP        _ACCB, _ACCA
                        BRCS      SYSTEM._L0153
                        BRNE      SYSTEM._L0154
                        CP        _ACCELO, _ACCCLO
                        BRCS      SYSTEM._L0153
                        BRNE      SYSTEM._L0154
                        CP        _ACCDHI, _ACCBHI
                        BRCS      SYSTEM._L0153
                        BRNE      SYSTEM._L0154
                        CP        _ACCDLO, _ACCBLO
                        BRCS      SYSTEM._L0153
SYSTEM._L0154:
                        MOVW      _ACCB, _ACCDLO
                        MOVW      _ACCALO, _ACCELO
                        MOV       _ACCDHI, _ACCBHI
                        MOV       _ACCDLO, _ACCBLO
                        MOV       _ACCEHI, _ACCCHI
                        MOV       _ACCELO, _ACCCLO
                        MOVW      _ACCBLO, _ACCB
                        MOVW      _ACCCLO, _ACCALO
                        RJMP      SYSTEM._L0163
SYSTEM._L0153:
                        MOVW      _ACCB, _ACCBLO
                        MOVW      _ACCALO, _ACCCLO
SYSTEM._L0163:
                        ANDI      _ACCALO, 07Fh
                        ORI       _ACCALO, 080h
                        CLR       _ACCAHI
                        SBRS      _ACCCHI, 7
                        RJMP      SYSTEM._L0155
                        SUBI      _ACCB, 01h
                        SBCI      _ACCA, 00h
                        SBCI      _ACCALO, 00h
                        SBCI      _ACCAHI, 00h
                        COM       _ACCALO
                        COM       _ACCAHI
                        COM       _ACCA
                        COM       _ACCB
SYSTEM._L0155:
                        PUSH      _ACCA
                        MOV       _ACCFHI, _ACCCHI
                        MOV       _ACCFLO, _ACCCLO
                        ROL       _ACCFLO
                        ROL       _ACCFHI
                        MOV       _ACCFLO, _ACCEHI
                        MOV       _ACCGLO, _ACCELO
                        ROL       _ACCGLO
                        ROL       _ACCFLO
                        MOV       _ACCGHI, _ACCDHI
                        MOV       _ACCGLO, _ACCDLO
                        MOV       _ACCHLO, _ACCELO
                        LDI       _ACCA, 080h
                        OR        _ACCHLO, _ACCA
                        CLR       _ACCHHI
                        MOV       _ACCA, _ACCFHI
                        SUB       _ACCA, _ACCFLO
                        TST       _ACCA
SYSTEM._L0156:
                        BREQ      SYSTEM._L0157
                        LSR       _ACCHLO
                        ROR       _ACCGHI
                        ROR       _ACCGLO
                        DEC       _ACCA
                        RJMP      SYSTEM._L0156
SYSTEM._L0157:
                        MOV       _ACCA, _ACCEHI
                        MOV       _ACCDLO, _ACCGLO
                        MOV       _ACCDHI, _ACCGHI
                        MOV       _ACCELO, _ACCHLO
                        MOV       _ACCEHI, _ACCHHI
                        SBRS      _ACCA, 7
                        RJMP      SYSTEM._L0158
                        SUBI      _ACCDLO, 01h
                        SBCI      _ACCDHI, 00h
                        SBCI      _ACCELO, 00h
                        SBCI      _ACCEHI, 00h
                        COM       _ACCDLO
                        COM       _ACCDHI
                        COM       _ACCEHI
                        COM       _ACCELO
SYSTEM._L0158:
                        POP       _ACCA
                        ADD       _ACCB, _ACCDLO
                        ADC       _ACCA, _ACCDHI
                        ADC       _ACCALO, _ACCELO
                        ADC       _ACCAHI, _ACCEHI
                        SBRS      _ACCAHI, 7
                        RJMP      SYSTEM._L0159
                        ORI       _ACCCHI, 080h
                        SUBI      _ACCB, 01h
                        SBCI      _ACCA, 00h
                        SBCI      _ACCALO, 00h
                        SBCI      _ACCAHI, 00h
                        COM       _ACCALO
                        COM       _ACCAHI
                        COM       _ACCA
                        COM       _ACCB
                        RJMP      SYSTEM._L0160
SYSTEM._L0159:
                        ANDI      _ACCCHI, 07Fh
SYSTEM._L0160:
                        MOV       _ACCFLO, _ACCAHI
                        ANDI      _ACCFLO, 07Fh
                        BREQ      SYSTEM._L0161
                        LSR       _ACCAHI
                        ROR       _ACCALO
                        ROR       _ACCA
                        ROR       _ACCB
                        INC       _ACCFHI
                        BRNE      SYSTEM._L0161
                        LDI       _ACCA, 0FFh
                        LDI       _ACCB, 0FFh
                        LDI       _ACCALO, 0FFh
                        LDI       _ACCAHI, 07Fh
                        SBRC      _ACCCHI, 7
                        ORI       _ACCAHI, 080h
                        SET
                        BLD       Flags, _ERRFLAG
                        RET
SYSTEM._L0161:
                        SBRC      _ACCALO, 7
                        RJMP      SYSTEM._L0162
                        TST       _ACCFHI
                        BREQ      SYSTEM._L0162
                        LSL       _ACCB
                        ROL       _ACCA
                        ROL       _ACCALO
                        ROL       _ACCAHI
                        DEC       _ACCFHI
                        RJMP      SYSTEM._L0161
SYSTEM._L0162:
                        MOV       _ACCAHI, _ACCFHI
                        CLR       _ACCFHI
                        LSR       _ACCAHI
                        TST       _ACCAHI
                        BREQ      SYSTEM._L0164
                        ROR       _ACCFHI
                        ANDI      _ACCALO, 07Fh
                        OR        _ACCALO, _ACCFHI
                        SBRC      _ACCCHI, 7
                        ORI       _ACCAHI, 080h
                        RET
SYSTEM._L0164:
                        CLR       _ACCALO
                        CLR       _ACCA
                        CLR       _ACCB
                        RET

SYSTEM.Float2Str_C:
                        PUSH      _ACCDHI
SYSTEM._L0166:
                        MOVW      _ACCELO, _ACCB
                        MOVW      _ACCFLO, _ACCALO
                        LDI       _ACCBLO, 07Fh
                        LDI       _ACCBHI, 096h
                        LDI       _ACCCLO, 018h
                        LDI       _ACCCHI, 04Bh
                        SET
                        BLD       Flags, _NEGATIVE
                        CLR       _ACCDHI
                        RCALL     SYSTEM.HighF
                        MOVW      _ACCB, _ACCELO
                        MOVW      _ACCALO, _ACCFLO
                        TST       _ACCDHI
                        BRMI      SYSTEM._L0168
                        BREQ      SYSTEM._L0168
                        LDI       _ACCBLO, 000h
                        LDI       _ACCBHI, 024h
                        LDI       _ACCCLO, 074h
                        LDI       _ACCCHI, 049h
                        CLR       _ACCDHI
                        RCALL     SYSTEM.HighF
                        TST       _ACCDHI
                        BRMI      SYSTEM._L0169
                        BREQ      SYSTEM._L0169
                        POP       _ACCDHI
                        DEC       _ACCDHI
                        PUSH      _ACCDHI
                        LDI       _ACCBLO, 000h
                        LDI       _ACCBHI, 000h
                        LDI       _ACCCLO, 020h
                        LDI       _ACCCHI, 041h
SYSTEM._L0167:
                        MOV       _ACCDLO, _ACCELO
                        MOV       _ACCDHI, _ACCEHI
                        MOV       _ACCELO, _ACCFLO
                        MOV       _ACCEHI, _ACCFHI
                        CLT
                        BLD       Flags, _ERRFLAG
                        RCALL     SYSTEM.MulFloat_R
                        RJMP      SYSTEM._L0166
SYSTEM._L0168:
                        POP       _ACCDHI
                        INC       _ACCDHI
                        PUSH      _ACCDHI
                        LDI       _ACCBLO, 0CDh
                        LDI       _ACCBHI, 0CCh
                        LDI       _ACCCLO, 0CCh
                        LDI       _ACCCHI, 03Dh
                        RJMP      SYSTEM._L0167
SYSTEM._L0169:
                        POP       _ACCDHI
                        RET

SYSTEM.Float2Str:
                        LD        _ACCCLO, Y+
                        LD        _ACCBLO, Y+
                        LD        _ACCBHI, Y+
                        LD        _ACCB, Y+
                        LD        _ACCA, Y+
                        LD        _ACCALO, Y+
                        LD        _ACCAHI, Y+
                        PUSH      _FRAMEPTR
                        PUSH      _FPTRHI
                        LDI       _ACCEHI, 17
                        LDI       _ACCELO, 30h
SYSTEM._L0165:
                        ST        -Y, _ACCELO
                        DEC       _ACCEHI
                        BRNE      SYSTEM._L0165
                        CLR       _ACCGLO
                        STD       Y+0, _ACCGLO
                        STD       Y+14, _ACCBHI
                        STD       Y+15, _ACCBLO
                        STD       Y+16, _ACCCLO
                        CLT
                        BLD       Flags, _ERRFLAG
                        MOV       _ACCEHI, _ACCAHI
                        ANDI      _ACCEHI, 07Fh
                        TST       _ACCEHI
                        BRNE      SYSTEM._L0176
                        LDD       _ACCA, Y+15
                        LDI       _ACCB, DECIMALSEP
                        CPI       _ACCA, 45h
                        BRNE      SYSTEM._L0177
                        LDI       _ACCA, 0FFh
                        STD       Y+15, _ACCA
                        LDI       _ACCA, 30h
                        RCALL     SYSTEM.Float2Str_P
                        LDI       _ACCA, 45h
                        RCALL     SYSTEM.Float2Str_P
                        LDI       _ACCA, 30h
                        RCALL     SYSTEM.Float2Str_P
                        LDI       _ACCALO, 0FFh
                        LDD       _ACCAHI, Y+14
                        RJMP      SYSTEM.Float2Str_F
SYSTEM._L0177:
                        LDI       _ACCA, 30h
                        RCALL     SYSTEM.Float2Str_P
                        LDI       _ACCA, DECIMALSEP
                        RCALL     SYSTEM.Float2Str_P
                        LDI       _ACCA, 30h
                        RCALL     SYSTEM.Float2Str_P
                        RCALL     SYSTEM.Float2Str_R
                        RJMP      SYSTEM.Float2Str_F
SYSTEM._L0176:
                        LDD       _ACCCHI, Y+15
                        CPI       _ACCCHI, 45h
                        BREQ      SYSTEM._L0178
                        CP        _ACCBLO, _ACCBHI
                        BRCS      SYSTEM._L0178
                        MOV       _ACCBHI, _ACCBLO
                        INC       _ACCBHI
                        STD       Y+14, _ACCBHI
SYSTEM._L0178:
                        CLR       _ACCDHI
                        TST       _ACCAHI
                        BRPL      SYSTEM._L0175
                        ANDI      _ACCAHI, 07Fh
                        PUSH      _ACCA
                        LDI       _ACCA, 2Dh
                        RCALL     SYSTEM.Float2Str_P
                        POP       _ACCA
SYSTEM._L0175:
                        RCALL     SYSTEM.Float2Str_C
                        PUSH      _ACCDHI
                        PUSH      _ACCELO
                        PUSH      _ACCEHI
                        PUSH      _ACCFLO
                        PUSH      _ACCFHI
                        LDI       _ACCB, 000h
                        LDI       _ACCA, 000h
                        LDI       _ACCALO, 000h
                        LDI       _ACCAHI, 03Fh
                        LDD       _ACCDLO, Y+15
                        LDD       _ACCBLO, Y+14
                        SUBI      _ACCDHI, -8 AND 0FFh
                        CPI       _ACCDHI, 8
                        BRGE      SYSTEM._L0181
                        CPI       _ACCDHI, -5 AND 0FFh
                        BRLT      SYSTEM._L0181
                        CPI       _ACCDLO, 45h
                        BREQ      SYSTEM._L0181
                        TST       _ACCBLO
                        BRNE      SYSTEM._L0179
                        SUB       _ACCDLO, _ACCDHI
SYSTEM._L0179:
                        MOV       _ACCBLO, _ACCDHI
                        LDI       _ACCDHI, 9
                        SUB       _ACCDHI, _ACCDLO
                        SUB       _ACCDHI, _ACCBLO
                        BRMI      SYSTEM._L0182
                        BRNE      SYSTEM._L0180
                        COM       _ACCDHI
                        STD       Y+15, _ACCDHI
                        RJMP      SYSTEM._L0181
SYSTEM._L0180:
                        DEC       _ACCDHI
                        BREQ      SYSTEM._L0181
                        PUSH      _ACCDHI
                        MOVW      _ACCDLO, _ACCB
                        MOVW      _ACCELO, _ACCALO
                        LDI       _ACCBLO, 000h
                        LDI       _ACCBHI, 000h
                        LDI       _ACCCLO, 020h
                        LDI       _ACCCHI, 041h
                        CLT
                        BLD       Flags, _ERRFLAG
                        RCALL     SYSTEM.MulFloat_R
                        POP       _ACCDHI
                        RJMP      SYSTEM._L0180
SYSTEM._L0182:
SYSTEM._L0181:
                        CLT
                        BLD       Flags, _ERRFLAG
                        RCALL     SYSTEM.AddFloat
                        POP       _ACCDHI
                        RCALL     SYSTEM.Float2Str_C
                        PUSH      _ACCDHI
                        MOVW      _ACCELO, _ACCB
                        MOVW      _ACCFLO, _ACCALO
                        ROL       _ACCALO
                        ROL       _ACCAHI
                        ORI       _ACCFLO, 80h
                        SUBI      _ACCAHI, 81h
                        NEG       _ACCAHI
                        SUBI      _ACCAHI, -21 AND 0FFh
                        RJMP      SYSTEM._L0171
SYSTEM._L0170:
                        LSR       _ACCFLO
                        ROR       _ACCEHI
                        ROR       _ACCELO
                        DEC       _ACCAHI
SYSTEM._L0171:
                        BRNE      SYSTEM._L0170
                        POP       _ACCBHI
                        LDI       _ACCBLO, 1
                        LDD       _ACCDLO, Y+15
                        CPI       _ACCDLO, 45h
                        BRNE      SYSTEM._L0183
                        SUBI      _ACCBHI, -8 AND 0FFh
                        MOV       _ACCALO, _ACCBHI
                        BRPL      SYSTEM._L0184
                        NEG       _ACCALO
SYSTEM._L0184:
                        RJMP      SYSTEM._L0172
SYSTEM._L0183:
                        LDI       _ACCALO, 7
                        SUBI      _ACCBHI, -8 AND 0FFh
                        CPI       _ACCBHI, 8
                        BRGE      SYSTEM._L0172
                        CPI       _ACCBHI, -5 AND 0FFh
                        BRLT      SYSTEM._L0172
                        DEC       _ACCBHI
                        MOV       _ACCBLO, _ACCBHI
                        LDI       _ACCBHI, 2
SYSTEM._L0172:
                        SUBI      _ACCBHI, 2
                        TST       _ACCBLO
                        BREQ      SYSTEM._L0186
                        BRPL      SYSTEM._L0173
SYSTEM._L0186:
                        LDI       _ACCA, 30h
                        RCALL     SYSTEM.Float2Str_P
                        LDI       _ACCA, DECIMALSEP
                        RCALL     SYSTEM.Float2Str_P
                        TST       _ACCBLO
                        BREQ      SYSTEM._L0173
SYSTEM._L0185:
                        LDI       _ACCA, 30h
                        RCALL     SYSTEM.Float2Str_P
                        DEC       _ACCALO
                        INC       _ACCBLO
                        BRNE      SYSTEM._L0185
SYSTEM._L0173:
                        LDI       _ACCCLO, SYSTEM.DECDIG AND 0FFh
                        LDI       _ACCCHI, SYSTEM.DECDIG SHRB 8
SYSTEM._L0174:
                        CLR       _ACCAHI
SYSTEM._L0187:
                        LPM       _ACCB, Z+
                        LPM       _ACCA, Z
                        ADIW      _ACCCLO, 1
                        LPM
                        ADIW      _ACCCLO, 02h
SYSTEM._L0192:
                        SUB       _ACCELO, _ACCB
                        SBC       _ACCEHI, _ACCA
                        SBC       _ACCFLO, _ACCGLO
                        BRCS      SYSTEM._L0188
                        INC       _ACCAHI
                        RJMP      SYSTEM._L0192
SYSTEM._L0188:
                        ADD       _ACCELO, _ACCB
                        ADC       _ACCEHI, _ACCA
                        ADC       _ACCFLO, _ACCGLO
                        CPI       _ACCAHI, 10
                        BRLT      SYSTEM._L0193
                        LDI       _ACCAHI, 1
                        INC       _ACCBHI
SYSTEM._L0193:
                        LDI       _ACCA, 30h
                        ADD       _ACCA, _ACCAHI
                        RCALL     SYSTEM.Float2Str_P
                        DEC       _ACCBLO
                        BRNE      SYSTEM._L0189
                        LDI       _ACCA, DECIMALSEP
                        RCALL     SYSTEM.Float2Str_P
SYSTEM._L0189:
                        DEC       _ACCALO
                        BRMI      SYSTEM._L0190
                        BRNE      SYSTEM._L0174
SYSTEM._L0190:
                        RCALL     SYSTEM.Float2Str_R
                        TST       _ACCBHI
                        BREQ      SYSTEM.Float2Str_F
                        LDI       _ACCA, 0FFh
                        STD       Y+15, _ACCA
                        LDI       _ACCA, 45h
                        RCALL     SYSTEM.Float2Str_P
                        TST       _ACCBHI
                        BRPL      SYSTEM._L0191
                        NEG       _ACCBHI
                        LDI       _ACCA, 2Dh
                        RCALL     SYSTEM.Float2Str_P
SYSTEM._L0191:
                        LDI       _ACCB, 10
                        MOV       _ACCA, _ACCBHI
                        RCALL     SYSTEM.DIV8_R
                        TST       _ACCA
                        BREQ      SYSTEM._L0195
                        ORI       _ACCA, 30h
                        RCALL     SYSTEM.Float2Str_P
SYSTEM._L0195:
                        MOV       _ACCA, _ACCB
                        ORI       _ACCA, 30h
                        RCALL     SYSTEM.Float2Str_P
SYSTEM.Float2Str_F:
                        POP       _ACCCHI
                        POP       _ACCCLO
                        MOVW      _ACCBLO, _FRAMEPTR
                        LDD       _ACCALO, Y+15
                        LDD       _ACCAHI, Y+14
                        SBIW      _FRAMEPTR, 3
                        LDD       _ACCB, Z+0
                        STD       Y+0, _ACCB
                        LDD       _ACCB, Z+1
                        STD       Y+1, _ACCB
                        LDD       _ACCB, Z+2
                        STD       Y+2, _ACCB
                        CPI       _ACCALO, 0FFh
                        BREQ      SYSTEM._L0197
                        TST       _ACCAHI
                        BREQ      SYSTEM._L0197
                        TST       _ACCALO
                        BRNE      SYSTEM._L0196
                        RCALL     SYSTEM.Float2Str_D
                        ST        X, _ACCDHI
                        RJMP      SYSTEM._L0197
SYSTEM._L0196:
                        RCALL     SYSTEM.Float2Str_D
                        LD        _ACCDLO, X
                        SUB       _ACCAHI, _ACCALO
                        DEC       _ACCAHI
                        SUB       _ACCAHI, _ACCDHI
                        BREQ      SYSTEM._L0202
                        BRCS      SYSTEM._L0202
                        LDD       _ACCA, Y+16+3
SYSTEM._L0200:
                        RCALL     SYSTEM.Char2Str
                        DEC       _ACCAHI
                        BRNE      SYSTEM._L0200
SYSTEM._L0202:
                        ST        X, _ACCDHI
                        RCALL     SYSTEM.Float2Str_W
                        LDI       _ACCA, DECIMALSEP
                        RCALL     SYSTEM.Char2Str
                        ADIW      _ACCBLO, 1
                        SUB       _ACCDLO, _ACCDHI
SYSTEM._L0204:
                        DEC       _ACCDLO
                        BREQ      SYSTEM._L0203
                        LD        _ACCA, X+
                        RCALL     SYSTEM.Char2Str
                        DEC       _ACCALO
                        BREQ      SYSTEM._L0201
                        RJMP      SYSTEM._L0204
SYSTEM._L0203:
                        LDI       _ACCA, 030h
                        RCALL     SYSTEM.Char2Str
                        DEC       _ACCALO
                        BRNE      SYSTEM._L0203
                        RJMP      SYSTEM._L0201
SYSTEM._L0197:
                        LD        _ACCB, X
                        SUB       _ACCAHI, _ACCB
                        BREQ      SYSTEM._L0199
                        BRCS      SYSTEM._L0199
                        LDD       _ACCA, Y+16+3
SYSTEM._L0198:
                        RCALL     SYSTEM.Char2Str
                        DEC       _ACCAHI
                        BRNE      SYSTEM._L0198
SYSTEM._L0199:
                        RCALL     SYSTEM.Float2Str_W
SYSTEM._L0201:
                        LDD       _ACCB, Y+0
                        STD       Z+0, _ACCB
                        LDD       _ACCB, Y+1
                        STD       Z+1, _ACCB
                        LDD       _ACCB, Y+2
                        STD       Z+2, _ACCB
                        MOVW      _FRAMEPTR, _ACCCLO
                        RET

SYSTEM.Float2Str_W:
                        LD        _ACCB, X+
SYSTEM._L0205:
                        LD        _ACCA, X+
                        RCALL     SYSTEM.Char2Str
                        DEC       _ACCB
                        BRNE      SYSTEM._L0205
                        RET

SYSTEM.Float2Str_D:
                        PUSH      _ACCBLO
                        PUSH      _ACCBHI
                        CLR       _ACCDHI
                        LD        _ACCB, X+
SYSTEM._L0206:
                        LD        _ACCA, X+
                        CPI       _ACCA, DECIMALSEP
                        BREQ      SYSTEM._L0207
                        INC       _ACCDHI
                        DEC       _ACCB
                        BRNE      SYSTEM._L0206
SYSTEM._L0207:
                        POP       _ACCBHI
                        POP       _ACCBLO
                        RET

SYSTEM.Float2Str_R:
                        LDD       _ACCCLO, Y+0
                        MOV       _ACCA, _ACCCLO
                        INC       _ACCCLO
                        CLR       _ACCCHI
                        ADD       _ACCCLO, _FRAMEPTR
                        ADC       _ACCCHI, _FPTRHI
SYSTEM._L0208:
                        DEC       _ACCA
                        LD        _ACCB, -Z
                        CPI       _ACCB, 030h
                        BREQ      SYSTEM._L0208
                        CPI       _ACCB, DECIMALSEP
                        BREQ      SYSTEM._L0209
                        INC       _ACCA
SYSTEM._L0209:
                        STD       Y+0, _ACCA
                        RET

SYSTEM.Float2Str_P:
                        PUSH      _ACCCLO
                        PUSH      _ACCCHI
                        LDD       _ACCCLO, Y+0
                        INC       _ACCCLO
                        STD       Y+0, _ACCCLO
                        CLR       _ACCCHI
                        ADD       _ACCCLO, _FRAMEPTR
                        ADC       _ACCCHI, _FPTRHI
                        STD       Z+0, _ACCA
                        POP       _ACCCHI
                        POP       _ACCCLO
                        RET


SYSTEM.DIV8:
                        POP       _ACCAHI
                        POP       _ACCALO
                        MOV       _ACCB, _ACCA
                        POP       _ACCA
                        PUSH      _ACCALO
                        PUSH      _ACCAHI
SYSTEM.DIV8_R:
                        CLR       _ACCAHI
                        LDI       _ACCALO, 9
SYSTEM._L0210:
                        ROL       _ACCA
                        DEC       _ACCALO
                        BRNE      SYSTEM._L0211
                        MOV       _ACCB, _ACCAHI
                        RET
SYSTEM._L0211:
                        ROL       _ACCAHI
                        SUB       _ACCAHI, _ACCB
                        BRCC      SYSTEM._L0212
                        ADD       _ACCAHI, _ACCB
                        CLC
                        RJMP      SYSTEM._L0210
SYSTEM._L0212:
                        SEC
                        RJMP      SYSTEM._L0210

SYSTEM.GETADC:
                        CLI
                        LDS       _ACCB, _ADCBUFF
                        LDS       _ACCA, _ADCBUFF +1
                        SBRC      Flags, IntFlag
                        SEI
                        RET

SYSTEM.SETADCFIXED:
                        RET

SYSTEM.DefIntErr:
                        RETI


                        .ROMCONST $

SYSTEM.DECDIG:
                        .Byte     040h
                        .Byte     042h
                        .Byte     00Fh
                        .Byte     000h
                        .Byte     0A0h
                        .Byte     086h
                        .Byte     001h
                        .Byte     000h
SYSTEM.IntDivTab:
                        .Byte     010h
                        .Byte     027h
                        .Byte     000h
                        .Byte     000h
                        .Byte     0E8h
                        .Byte     003h
                        .Byte     000h
                        .Byte     000h
                        .Byte     064h
                        .Byte     000h
                        .Byte     000h
                        .Byte     000h
                        .Byte     00Ah
                        .Byte     000h
                        .Byte     000h
                        .Byte     000h
SYSTEM.StrDivTabX:
                        .Byte     001h
                        .Byte     000h
                        .Byte     000h
                        .Byte     000h

                        ; ============ String-constant tables ============
$St_String1:
                        .BYTE     17
                        .ASCII    "      AVRco      "

$St_String2:
                        .BYTE     20
                        .ASCII    "   ELAB Computer    "

$St_String3:
                        .BYTE     20
                        .ASCII    "ESSAI LIAISON  SERIE"

$St_String4:
                        .BYTE     20
                        .ASCII    "P.G Vox         V1.0"

$St_String5:
                        .BYTE     16
                        .ASCII    "Caracteres recus"

$St_String6:
                        .BYTE     6
                        .ASCII    "VCAN: "

$St_String7:
                        .BYTE     3
                        .ASCII    " =>"

$St_String8:
                        .BYTE     20
                        .ASCII    "                    "

$St_String9:
                        .BYTE     14
                        .ASCII    "Envoi Bonjour "

$St_String10:
                        .BYTE     9
                        .ASCII    "Envoi CAN"


                        ; ============ Fixed addr String-constant tables ============

                        ; ============ fixed addr array-constant tables ============

                        ; ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        ; Reset and Interrupt vectors
                        ; ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


                        .ENDCODE
SYSTEM.ENDCODE:
                        .ORG       000000h, VECTTAB
                        .VECTTAB
SYSTEM.VectTab:
                        RJMP      SYSTEM.RESET
                        RJMP      SYSTEM.DefIntErr
                        RJMP      SYSTEM.DefIntErr
                        RJMP      SYSTEM.DefIntErr
                        RJMP      SYSTEM.DefIntErr
                        RJMP      SYSTEM.DefIntErr
                        RJMP      SYSTEM.DefIntErr
                        RJMP      SYSTEM.DefIntErr
                        RJMP      SYSTEM.DefIntErr
                        RJMP      SYSTEM.DefIntErr
                        RJMP      SYSTEM.DefIntErr
                        RJMP      SYSTEM.DefIntErr
                        RJMP      SYSTEM.DefIntErr
                        RJMP      SYSTEM.DefIntErr
                        RJMP      SYSTEM.DefIntErr
                        RJMP      SYSTEM.DefIntErr
                        RJMP      SYSTEM.$INTERRUPT_TIMER0
                        RJMP      SYSTEM.DefIntErr
                        RJMP      SYSTEM.$INTERRUPT_RXRDY
                        RJMP      SYSTEM.$INTERRUPT_TXEMPTY
                        RJMP      SYSTEM.DefIntErr
                        RJMP      SYSTEM.DefIntErr
                        RJMP      SYSTEM.DefIntErr
                        RJMP      SYSTEM.DefIntErr
                        RJMP      SYSTEM.DefIntErr
                        RJMP      SYSTEM.DefIntErr

                        .VECTTABE
SYSTEM.ENDPROG:

                        .END

                        ; ============ End of Program ============


                        ; System uses registers
                        ; from bottom     = 00000h
                        ; upto            = 00006h
                        ; and
                        ; from            = 00010h
                        ; upto            = 0001Fh
                        ;
                        ; Stackframe at   = ...00208h


                        ; ===== Current top of User Vars in Data is 00006h =====

                        ; ===== Current top of User Vars in IData is 0023Ah =====

                        ; ===== EEprom currently not used =====


                        ; ===== Imported Library Routines =====

                        ; Divide       byte DIV8
                        ; Higher float
                        ; LongWord and LongInt types
                        ; Convert int to string
                        ; Floating point type
                        ; float multiply
                        ; float add
                        ; float int to float
                        ; float float to string

                        ; Pascal Statements : 73
                        ; Assembler Lines   : 7021
                        ; Optimizer removed : 16 lines = 32Bytes

                        ; >> real SysTick (exact): 9.984 msec <<

